<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_GISEH_FORME_ART_RUB")) return;
define("_ECRIRE_GISEH_FORME_ART_RUB", "1");

if (file_exists('./inc_version.php3')) {
	include_once("inc_version.php3");
} else {
	include_once("ecrire/inc_version.php3");
}

function cilisterubheritage($ciliste) {
	static $cilistetoutesrub;
	if ($ciliste) $cilistetoutesrub.=$ciliste.", ";
	return $cilistetoutesrub;
}

function cilisterubriqueforme($cimotcle) {

$liste_rubriques = "0";

	if ($cimotcle) {
		$query = "SELECT rubriques.id_rubrique FROM spip_rubriques AS rubriques,spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE rubriques.id_rubrique=lien_mot.id_rubrique AND lien_mot.id_mot=mots.id_mot AND mots.titre='".$cimotcle."' AND mots.type='_forme_rubrique' GROUP BY rubriques.id_rubrique";
		    $result = @spip_query($query);
		
		    if ($result){
			if (spip_num_rows($result)>=1) {
			    	while ($row = @spip_fetch_array($result)) {
			    		$cirubriques[] = $row['id_rubrique'];
			    	}
			       	$liste_rubriques = implode(", ",$cirubriques);
			}
		    }	
	}	    
    	return $liste_rubriques;
}


function cilistearticleheritier($cimotcle) {
	$liste_articles = "";
	
	if ($cimotcle) {
	
		$cilisterub=cilisterubriqueforme($cimotcle);
		if ($cilisterub){
			if (!$cilisterub=="0"){
				$ci = cilisterubheritage($cilisterub);
			}
		}
		$query = "SELECT articles.id_article,articles.id_rubrique FROM spip_articles AS articles WHERE articles.id_rubrique IN (".$cilisterub.")";
		$result = spip_query($query);
		if ($result){
			while($row = spip_fetch_array($result)) {
				$liste_articles .= $row['id_article'].' => "'.$cimotcle.'", ';
			}
		}
	}	    
		
 	return $liste_articles;
}


function ci_maj_forme_article() {
	$ci_forme_article = "";
	$ci_tab_id_mot = array();
	$ci_tab_titre_mot = array();
	$ci_liste_id_mot = "(0)";
	$ci_tab_id_article = array();
	$ci_liste_id_article = "(0)";
	$ci_tab_id_article_final = array();
	$ci_liste_id_article_final = "(0)";
	
	$ci_forme_article .= cilistearticleheritier("_forum");
	$ci_forme_article .= cilistearticleheritier("_forumhierarchique");
	$ci_forme_article .= cilistearticleheritier("_cartesites");
	$ci_forme_article .= cilistearticleheritier("_cartesites2");
	$ci_forme_article .= cilistearticleheritier("_cartesites3");
	
	$cilistetoutesrub =cilisterubheritage("");

	$query = "SELECT id_mot,titre FROM spip_mots WHERE titre<>'kawax' AND type='_forme_article'";
	$result = spip_query($query);
    if ($result){
		if (spip_num_rows($result)>=1) {
		    	while ($row = @spip_fetch_array($result)) {
		    		$ci_tab_id_mot[] = $row['id_mot'];
		    		$ci_tab_titre_mot[$row['id_mot']] = $row['titre'];
		    	}
		       	$ci_liste_id_mot = "( ".implode(", ",$ci_tab_id_mot).", 0)";
		}
    }	

	$query = "SELECT id_article FROM spip_mots_articles WHERE id_mot IN ".$ci_liste_id_mot;
	$result = spip_query($query);
    if ($result){
		if (spip_num_rows($result)>=1) {
		    	while ($row = @spip_fetch_array($result)) {
		    		$ci_tab_id_article[] = $row['id_article'];
		    	}
		       	$ci_liste_id_article = "( ".implode(", ",$ci_tab_id_article).", 0)";
		}
    }	

	$query = "SELECT id_article FROM spip_articles WHERE id_article IN ".$ci_liste_id_article." AND id_rubrique NOT IN (".$cilistetoutesrub."0)"; 
	$result = spip_query($query);
    if ($result){
		if (spip_num_rows($result)>=1) {
		    	while ($row = @spip_fetch_array($result)) {
		    		$ci_tab_id_article_final[] = $row['id_article'];
		    	}
		       	$ci_liste_id_article_final = "( ".implode(", ",$ci_tab_id_article).", 0)";
		}
    }	
    

//	$query = "SELECT rel_mots.id_article, mots.titre FROM spip_articles AS articles, spip_mots_articles AS rel_mots, spip_mots AS mots WHERE mots.titre<>'kawax' AND mots.id_mot=rel_mots.id_mot AND mots.type='_forme_article' AND articles.id_rubrique NOT IN (".$cilistetoutesrub."0) GROUP BY rel_mots.id_article";
	$query = "SELECT id_article, id_mot FROM spip_mots_articles WHERE id_article IN ".$ci_liste_id_article_final." AND id_mot IN ".$ci_liste_id_mot." GROUP BY id_article";
	$result = spip_query($query);
	while($row = spip_fetch_array($result)) {
		$ci_forme_article .= $row['id_article'].' => "'.$ci_tab_titre_mot[$row['id_mot']].'", ';
	}
	
	$ci_forme_article .= '0 => ""';

	// pour les multisites ce tableau est stock sur le site principal
	$cisecondaire= false;
	if (cilire_config('cimultisites')=="oui" AND cilire_config('ciIMG')!="IMG") {
		$cisecondaire= true;
		$cirepsiteprincipal= substr(cilire_config('ciIMG'),0,strlen(cilire_config('ciIMG'))-3);
	}

	$fichier_session = "IMG/forme_article.php3";
	if ($cisecondaire) {
		$fichier_session = $cirepsiteprincipal.$fichier_session;
	} 
	if (file_exists('./inc_version.php3')) {
		$fichier_session = "../".$fichier_session;
	}

	$texte = "<"."?php \$tableau_article=array(".$ci_forme_article."); ?".">";	
	$fd = fopen($fichier_session, "wb");
	fputs($fd, $texte);
	fclose($fd);
	
	return true;
}


function ci_maj_forme_rubrique() {
	$ci_forme_rubrique = "";
	$ci_tab_id_mot = array();
	$ci_tab_titre_mot = array();

	$query = "SELECT id_mot,titre FROM spip_mots WHERE titre<>'kawax' AND type='_forme_rubrique'";
	$result = spip_query($query);
    if ($result){
		if (spip_num_rows($result)>=1) {
		    	while ($row = @spip_fetch_array($result)) {
		    		$ci_tab_id_mot[] = $row['id_mot'];
		    		$ci_tab_titre_mot[$row['id_mot']] = $row['titre'];
		    	}
		       	$ci_liste_id_mot = "( ".implode(", ",$ci_tab_id_mot).", 0)";
		}
    }
	
//	$query = "SELECT id_rubrique, titre FROM spip_mots_rubriques AS rel_mots, spip_mots AS mots WHERE mots.titre<>'kawax' AND mots.id_mot=rel_mots.id_mot AND mots.type='_forme_rubrique' GROUP BY rel_mots.id_rubrique";
	$query = "SELECT id_rubrique, id_mot FROM spip_mots_rubriques WHERE id_mot IN ".$ci_liste_id_mot." GROUP BY id_rubrique";
	$result = spip_query($query);
	while($row = spip_fetch_array($result)) {
		$ci_forme_rubrique .= $row['id_rubrique'].' => "'.$ci_tab_titre_mot[$row['id_mot']].'", ';
	}
	
	$ci_forme_rubrique .= '0 => ""';

	// pour les multisites ce tableau est stock sur le site principal
	$cisecondaire= false;
	if (cilire_config('cimultisites')=="oui" AND cilire_config('ciIMG')!="IMG") {
		$cisecondaire= true;
		$cirepsiteprincipal= substr(cilire_config('ciIMG'),0,strlen(cilire_config('ciIMG'))-3);
	}

	$fichier_session = "IMG/forme_rubrique.php3";
	if ($cisecondaire) {
		$fichier_session = $cirepsiteprincipal.$fichier_session;
	} 
	if (file_exists('./inc_version.php3')) {
		$fichier_session = "../".$fichier_session;
	}
	
	$texte = "<"."?php \$tableau_rubrique=array(".$ci_forme_rubrique."); ?".">";
	$fd = fopen($fichier_session, "wb");
	fputs($fd, $texte);
	fclose($fd);
	
	return true;
}


function ci_maj_tri_rubrique() {
	$ci_tri_rubrique = "";
	$ci_tab_id_mot = array();
	$ci_tab_titre_mot = array();

	$query = "SELECT id_mot,titre FROM spip_mots WHERE titre<>'kawax' AND type='_articles_ordre_de_tri'";
	$result = spip_query($query);
    if ($result){
		if (spip_num_rows($result)>=1) {
		    	while ($row = @spip_fetch_array($result)) {
		    		$ci_tab_id_mot[] = $row['id_mot'];
		    		$ci_tab_titre_mot[$row['id_mot']] = $row['titre'];
		    	}
		       	$ci_liste_id_mot = "( ".implode(", ",$ci_tab_id_mot).", 0)";
		}
    }
	
//	$query = "SELECT id_rubrique, titre FROM spip_mots_rubriques AS rel_mots, spip_mots AS mots WHERE mots.titre<>'kawax' AND mots.id_mot=rel_mots.id_mot AND mots.type='_articles_ordre_de_tri' GROUP BY rel_mots.id_rubrique";
	$query = "SELECT id_rubrique, id_mot FROM spip_mots_rubriques WHERE id_mot IN ".$ci_liste_id_mot." GROUP BY id_rubrique";
	$result = spip_query($query);
	while($row = spip_fetch_array($result)) {
		$ci_tri_rubrique .= $row['id_rubrique'].' => "'.$ci_tab_titre_mot[$row['id_mot']].'", ';
	}
	
	$ci_tri_rubrique .= '0 => ""';

	// pour les multisites ce tableau est stock sur le site principal
	$cisecondaire= false;
	if (cilire_config('cimultisites')=="oui" AND cilire_config('ciIMG')!="IMG") {
		$cisecondaire= true;
		$cirepsiteprincipal= substr(cilire_config('ciIMG'),0,strlen(cilire_config('ciIMG'))-3);
	}

	$fichier_session = "IMG/tri_rubrique.php3";
	if ($cisecondaire) {
		$fichier_session = $cirepsiteprincipal.$fichier_session;
	} 
	if (file_exists('./inc_version.php3')) {
		$fichier_session = "../".$fichier_session;
	}
	
	$texte = "<"."?php \$tableau_tri_rubrique=array(".$ci_tri_rubrique."); ?".">";
	$fd = fopen($fichier_session, "wb");
	fputs($fd, $texte);
	fclose($fd);
	
	return true;
}


?>