<?php

//------Debut ajout CI (import liste auteurs) ------------

/*
Utilitaire d'importation d'une liste d'auteurs

Cet utilitaire offre  l'administrateur du site la possibilit d'importer une liste d'auteurs pralablement (le fichier est intitul annuaire.csv) afin d'viter de les saisir manuellement.
Une fois que ce fichier a t tlcharg (par un mcanisme identique au tlchargement de l'image du bandeau haut du site), le triatement offre  l'administrateur du site le choix du statut par dfaut qui sera affect  ces auteurs ('visiteur', 'rdacteur', etc.).
Le login par dfaut sera 'prenom.nom' (la partie de l'adresse lectronique situe  gauche de l'arobase).
Le mot de passe par dfaut sera le nom de l'auteur (tel qu'il figure dans son adresse lectronique) suivi d'une squence de caractres que l'administrateur du site peut choisir dans une liste droulante.
Si un auteur a dj t cre, il ne sera pas import (la vrification porte sur l'adresse lectronique).
L'administrateur du site est inform du nombre d'auteurs imports et du nombre d'auteurs figurant dans le fichier  importer.
Le fichier import est supprim  la fin du traitement.

Le fichier a importer sera obligatoirement intitul annuaire.csv et aura la structure suivante :

"Prnom","Nom","Messagerie"
"Yves","Montand","yves.montand@gmail.com"
"Jean","Dupond","jean.dupond@yahoo.fr"

La premire ligne du fichier contient la dfinition des en-ttes


Fichiers modifis corrlativement : 
- _giseh_motcle.php3, _giseh_version.php3 (ajout du format CSV dans les types de pices jointes)
- spip_image.php3 (autoriser l'upload du fichier annuaire.csv dans la fonction relative aux logos)
- auteurs.php3 (ajout d'un lien vers le prsent fichier)

*/


include ("inc.php3");
include_ecrire ("inc_logos.php3");
include_ecrire ("inc_acces.php3");

function ci_afficher_boite_upload_auteurs() {

    $logo = "annuaire";
    $texteon = "Tlchargement de la liste des auteurs";

	echo "<p>";
	debut_cadre_relief("doc-24.gif");
	echo "<center><font size='2' FACE='Verdana,Arial,Helvetica,sans-serif'>";
	echo "<b>";
	echo bouton_block_invisible(md5($texteon));
	echo $texteon;
	echo "</b>";

	ci_afficher_upload_auteur($logo, $texteon);

	echo "</font></center>";
	fin_cadre_relief();

	$cichemin = '../IMG/';
	if (file_exists($cichemin."annuaire.csv")) {
		
		debut_cadre_relief();
		echo "<font size=2>";
		echo "<FORM ACTION='_giseh_import_auteurs.php3' METHOD='post'>";
		echo "<INPUT TYPE='Hidden' NAME='action' VALUE='importer'>";
		echo "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=3 WIDTH=\"100%\" class='arial2'>";
		echo "<TR><TD>";
//		echo "<center>Statut par dfaut qui sera appliqu  tous les auteurs imports<br>";
		echo "Statut par dfaut qui sera appliqu  tous les auteurs imports : ";
		echo "</TD><TD>";
		echo " <SELECT NAME='choixstatut' SIZE=1 CLASS='fondl'>";
	
		echo "<OPTION VALUE='0minirezo'>"._T('item_administrateur_2');
	
		echo "<OPTION VALUE='1comite' SELECTED>"._T('intem_redacteur');
		//--------- Debut ajout CI (statut ciredval) ---------------------
		echo "<OPTION VALUE='ciredval'>"._T('item_ciredval');
		//--------- Fin ajout CI ---------------------
	
		//--------- Debut ajout CI (permettre de crer un visiteur) ---------------------
		//	if (($statut == '6forum') OR (lire_meta('accepter_visiteurs') == 'oui') OR (lire_meta('forums_publics') == 'abo'))
		//--------- Fin ajout CI ---------------------
			echo "<OPTION VALUE='6forum'>"._T('item_visiteur');
	
		echo "</SELECT></center>\n";
		echo "</TD></TR>";
		echo "<TR><TD>&nbsp;</TD><TD>&nbsp;</TD></TR>";
		echo "</TABLE>";

		echo "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=3 WIDTH=\"100%\" class='arial2'>";
		echo "<TR><TD>";
		echo "<input type='radio' name='passlight' value='oui' id='label_passlight' checked>";
		echo "</TD><TD>";
//		echo "<center>Le mot de passe initial sera le nom (tel qu'il figure dans l'adresse lectronique) suivi des caractres suivants : <br>";
		echo "<label for='label_passlight'><b>Le mot de passe initial sera le nom (tel qu'il figure dans l'adresse lectronique) suivi des caractres suivants : </b>";
		echo "</TD><TD>";
		echo " <SELECT NAME='choixextpass' SIZE=1 CLASS='fondl'>";
	
		echo "<OPTION SELECTED>_1";	
		echo "<OPTION >_2";
		echo "<OPTION >_3";
		echo "<OPTION >_a";
		echo "<OPTION >_m";
		echo "<OPTION >_p";
		
		echo "</SELECT></center>\n";
		echo "</TD></TR>";
		echo "<TR><TD>";
		echo "<input type='radio' name='passlight' value='non' id='label_passlourd'>";
		echo "</TD><TD>";
		echo "<label for='label_passlourd'>Le mot de passe initial sera gnr automatiquement (dans ce cas <font color='red'>il est <B>impratif</B> de noter ou d'imprimer les mots de passe dans la liste qui s'affiche  la fin de l'importation, car c'est le seul moment o ils seront visibles</font>)";
		echo "</TD><TD>&nbsp;";
		echo "</TD></TR>";
		echo "</TABLE>";
		echo "<br>";
		echo "<DIV align='right'><INPUT TYPE='submit' CLASS='fondo' NAME='valider' VALUE='Importer cette liste des auteurs'></DIV>";
		echo "</FORM>";
		echo "</font>";
		fin_cadre_relief();
	}		
	
}

function ci_afficher_upload_auteur($racine, $titre) {
	global $id_auteur, $connect_id_auteur;
	global $clean_link;

	$redirect = $clean_link->getUrl();
	$cichemin = '../IMG/';
	if (file_exists($cichemin."annuaire.csv")) {
		$fichier = 'annuaire.csv';	
		$taille=filesize($cichemin."annuaire.csv");
		if ($taille < 1024) {$taille = _T('taille_octets', array('taille' => $taille));}
		else if ($taille < 1024*1024) {
			$taille = _T('taille_ko', array('taille' => ((floor($taille / 102.4))/10)));
		} else {
			$taille = _T('taille_mo', array('taille' => ((floor(($taille / 1024) / 102.4))/10)));
		}
	}

	echo "<font size=1>";

	if ($fichier) {
		$hash = calculer_action_auteur("supp_logo $fichier");

		echo "<P><CENTER><a href='".$cichemin."annuaire.csv'><IMG SRC='../IMG/icones/txt-dist.png'></a>";
		echo debut_block_invisible(md5($titre));
		echo "$taille\n";
		echo "<BR>[<A HREF='../spip_image.php3?";
		echo "image_supp=$fichier&hash_id_auteur=$connect_id_auteur&id_auteur=$id_auteur&hash=$hash&redirect=$redirect'>"._T('lien_supprimer')."</A>]";
		echo fin_block();
		echo "</CENTER>";
		
		
		
	} else {
		$hash = calculer_action_auteur("ajout_logo $racine");
		echo debut_block_invisible(md5($titre));

		echo "\n\n<FORM ACTION='../spip_image.php3' METHOD='POST' ENCTYPE='multipart/form-data'>";
		echo "\n<INPUT NAME='redirect' TYPE=Hidden VALUE='$redirect'>";
		echo "\n<INPUT NAME='hash_id_auteur' TYPE=Hidden VALUE='$connect_id_auteur'>";
		echo "\n<INPUT NAME='hash' TYPE=Hidden VALUE='$hash'>";
		echo "\n<INPUT NAME='ajout_logo' TYPE=Hidden VALUE='oui'>";
		echo "\n<INPUT NAME='logo' TYPE=Hidden VALUE='$racine'>";
		if (tester_upload()){
			if (defined('_CI_IMPORT_ANNUAIRE_I2')) {
				echo "\n ATTENTION : le fichier des auteurs doit tre pralablement export du site annuaire.intra.i2 (il est intitul annuaire.csv)<BR>";
			}
			echo "\n<INPUT NAME='image' TYPE=File CLASS='forml' style='font-size:9px;' SIZE=15>";
			echo "\n <div align='right'><INPUT NAME='ok' TYPE=Submit VALUE='"._T('bouton_telecharger')."' CLASS='fondo' style='font-size:9px;'></div>";
		}

		echo fin_block();
		echo "</FORM>\n";
	}

	echo "</font>";
}


function ci_import_auteurs() {
	global $choixstatut, $choixextpass,$passlight;
	
	$row = 0;
	$affected=0;
	$premierid=0;
	$tableaupass=array();
	$return=array();
	
	if (file_exists("../IMG/annuaire.csv")) {
		$statut="1comite";
		if ($choixstatut) {
			if ($choixstatut=="0minirezo" || $choixstatut=="1comite" || $choixstatut=="ciredval" || $choixstatut=="6forum") {
				$statut=$choixstatut;
			}
		}
		$extpass="_1";
		if ($choixextpass) {
			if ($choixextpass=="_1" || $choixextpass=="_2" || $choixextpass=="_3" || $choixextpass=="_a" || $choixextpass=="_m" || $choixextpass=="_p") {
				$extpass=$choixextpass;
			}			
		}	
		
		$handle = fopen("../IMG/annuaire.csv", "r");
		if ($handle) {
			while ($data = fgetcsv($handle, 1000, ",")) {
				$idrow++;
				// La premire ligne contient les en-tetes
				if ($idrow>1) {
					if (defined('_CI_IMPORT_ANNUAIRE_I2')) {
						$email=$data[7];
					} else {
						$email=$data[2];
					}
					// si pas d'email on n'importe pas
					if ($p = strpos($email, '@')) {
						$email=strtolower(trim($email));
						// Vrification que cet email n'exite pas dj parmi les auteurs existants
						$query="SELECT id_auteur FROM spip_auteurs WHERE email='".$email."'";
						$result = spip_query($query);
						if (!(($n = @mysql_num_rows($result)) > 0)) {
							// Prparation de la requte
							$prenom_nom = substr($email, 0, $p);
							if ($p = strpos($prenom_nom, '.')) {
								$nom_email = substr($prenom_nom, $p+1);
							} else {
								// s'il n'y a pas de point
								$nom_email = $prenom_nom;
							}
							if ($passlight=='non'){
								$new_pass=creer_pass_aleatoire(8, $email);
							} else {	
								$new_pass=$nom_email.$extpass;
							}
							$htpass = generer_htpass($new_pass);
							$alea_actuel = creer_uniqid();
							$alea_futur = creer_uniqid();
							$pass = md5($alea_actuel.$new_pass);

							if (defined('_CI_IMPORT_ANNUAIRE_I2')) {
								$nom=addslashes($data[2].' '.$data[1]);
							} else {
								$nom=addslashes($data[1].' '.$data[0]);
							}
							$email=addslashes($email);
							$login=addslashes($prenom_nom);
							
							$query="INSERT INTO spip_auteurs
								(nom,email,statut,login,pass,htpass,alea_actuel,alea_futur)
								VALUES ('$nom','$email','$statut','$login','$pass','$htpass','$alea_actuel','$alea_futur')";
							spip_query($query);
							$affected=$affected+mysql_affected_rows();

							$query2="SELECT id_auteur FROM spip_auteurs WHERE email='".$email."'";
							$result2 = spip_query($query2);
							if ($row = spip_fetch_array($result2)) {
								// mmorise le mot de passe (non crypt)
								$tableaupass[$row['id_auteur']]=$new_pass;
								// mmorise le premier id ajout
								if ($idrow==2) {
									$premierid=$row['id_auteur'];
								}
							}	
						}	
					}
				}
			}
		fclose($handle);
		
		// Suppression du fichier d'import
		@unlink("../IMG/annuaire.csv");
		}
	}

	$return['affected']=$affected;
	if ($idrow>0) {
		$idrow--;
		$return['total']=$idrow;
	} else {
		$return['total']=0;
	}
	$return['premierid']=$premierid;
	$return['tableaupass']=$tableaupass;
	
	return $return;
}


debut_page(_T('titre_page_auteurs'),"redacteurs","redacteurs");

debut_gauche();

debut_droite();

if ($connect_statut != '0minirezo' OR !$connect_toutes_rubriques) {
	echo _T('avis_non_acces_page');
	fin_page();
	exit;
}


//
// Modifications
//

if ($action == 'importer') {
	$ret=ci_import_auteurs();
	spip_log("Nombre auteurs imports : ".$ret['affected']." / ".$ret['total']);
	echo "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=3 WIDTH=\"100%\">";
	echo "<TR><TD>";
	debut_cadre_relief();
	echo "<center><font size='2' FACE='Verdana,Arial,Helvetica,sans-serif'>";
	echo "<b>";
	echo "Traitement termin : ".$ret['affected']." auteurs ont t imports sur un total de ".$ret['total'];
	echo "</b>";
	if ($ret['total'] > $ret['affected']) echo "<br>Si un auteur a dj t cre, il n'est pas import (la vrification porte sur l'adresse lectronique).";
	echo "</font></center>";
	fin_cadre_relief();
	echo "</TD></TR>";	
	echo "<TR><TD>&nbsp;</TD></TR>";
	echo "</TABLE>\n";

	// affiche les auteurs imports
	if ($ret['affected']>0 AND $ret['premierid']>0) {
		$i=0;
		echo "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=0 WIDTH='100%' class='arial2'>\n";
		echo "<caption><font size='3'><b>Liste des auteurs imports</b></font><br><font size='3' color='red'><b>Il est IMPERATIF de noter ou imprimer ces login et mots de passe, car c'est le seul moment o ils sont visibles.</b></font><br>En effet, les mots de passe sont stocks dans la base de donnes avec un cryptage non rversible, aussi il ne sera pas possible de les lire ultrieurement. Par ailleurs, par mesure de scurit, un mot de passe ne doit pas tre envoy par messagerie.";
//--------- Debut ajout CI (version CAS) -----
		if (cilire_config("cicas")=="oui") {
			// Avertissement en cas d'authentification CAS
			echo "<BR>&nbsp;<BR>";
			debut_boite_info();
			echo "<FONT FACE='Georgia,Garamond,Times,serif' SIZE='2'>
			<P align='center'><B>"._T('avis_attention')."</B><P align='justify'>
			<img src='img_pack/warning.gif' alt='' width='48' height='48' align='right'>";
			echo "<b>L'authentification est ralise par Cerbre / CAS. Aussi les logins et les mots de passe gnrs lors de l'importation ne seront pas utiliss.</b> En effet, ce sont les logins et les mots de passe de Cerbre / CAS qui seront utiliss pour l'authentification.\n";
			echo "</FONT>";
			fin_boite_info();
			echo "<BR>&nbsp;<BR>";
		}	
//--------- Fin ajout CI ---------------------	
		echo "</caption>";
//		if ($passlight=='non'){
			echo "<TR bgcolor='#DBE1C5'><TH id='auteur'>Auteur</TH><TH id='login'>Login</TH><TH id='password'>Mot de passe</TH></TR>";
			$query="SELECT * FROM spip_auteurs WHERE id_auteur >=".$ret['premierid'];
			$result = spip_query($query);
			while($row=spip_fetch_array($result)){
				$couleur = ($i % 2) ? '#FFFFFF' : '#EDF3FE';
				$i++;
				echo "<TR bgcolor='$couleur'><TD headers='auteur'>".$row['nom']."</TD><TD headers='login'>".$row['login']."</TD><TD headers='password'>".$ret['tableaupass'][$row['id_auteur']]."</TD></TR>";
			}
/*			
		} else {	
			echo "<TR bgcolor='#DBE1C5'><TH id='auteur'>Auteur</TH><TH id='email'>Adresse lectronique</TH></TR>";
			$query="SELECT * FROM spip_auteurs WHERE id_auteur >=".$ret['premierid'];
			$result = spip_query($query);
			while($row=spip_fetch_array($result)){
				$couleur = ($i % 2) ? '#FFFFFF' : '#EDF3FE';
				$i++;
				echo "<TR bgcolor='$couleur'><TD headers='auteur'>".$row['nom']."</TD><TD headers='email'>".$row['email']."</TD></TR>";
			}
		}
*/			
		echo "</TABLE>\n";
		
	}

	echo "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=3 WIDTH=\"100%\">";
	echo "<TR><TD>&nbsp;</TD></TR>";
	echo "<TR><TD>";
	echo "<form action='auteurs.php3' method='get'>";
	echo "<center><input type='submit' name='Submit' class='fondo' value='Retour  la liste de tous les auteurs'></center>";
	echo "</form>";	
	echo "</TD></TR>";
	echo "</TABLE>\n";
	
} else {
	
	echo "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=3 WIDTH=\"100%\">";
	echo "<TR><TD>";

	debut_boite_info();
	echo "<FONT FACE='Georgia,Garamond,Times,serif' SIZE='2'>
	<P align='center'><B>"._T('avis_attention')."</B><P align='justify'>
	<img src='img_pack/warning.gif' alt='' width='48' height='48' align='right'>";
	if (defined('_CI_IMPORT_ANNUAIRE_I2')) {
		echo "Vous avez la possibilit d'importer une liste d'auteurs pralablement exporte du site annuaire.intra.i2 (le fichier est intitul annuaire.csv) afin d'viter de les saisir manuellement. Une fois que vous aurez tlcharg ce fichier sur le prsent site, vous pourrez choisir le statut par dfaut qui sera affect  ces auteurs ('visiteur', 'rdacteur', etc.). Vous pourrez bien sr modifier ultrieurement le statut d'un auteur particulier, toutefois, il est recommand de choisir le statut qui correspond au plus grand nombre d'auteurs. Le login par dfaut sera 'prenom.nom' (la partie de l'adresse lectronique situe  gauche de l'arobase). Le mot de passe par dfaut sera le nom de l'auteur (tel qu'il figure dans son adresse lectronique) suivi de plusieurs caractres que vous pourrez choisir OU BIEN les mots de passe seront gnrs automatiquement (dans ce cas <font color='red'>il est <B>impratif</B> de noter ou d'imprimer les mots de passe dans la liste qui s'affiche  la fin de l'importation, car c'est le seul moment o ils seront visibles</font>). Il est <B>indispensable</B> de demander aux utilisateurs de modifier ensuite leur mot de passe. Si un auteur a dj t cre, il ne sera pas import (la vrification porte sur l'adresse lectronique).<P align='justify'><B>Il est impratif d'utiliser un fichier qui respecte le nom, le format et la structure interne du fichier 'annuaire.csv' export du site annuaire.intra.i2</B> (dans le cas  contraire, les rsultats seront imprvisibles et vous devrez mettre  la poubelle un par un les auteurs imports).";
	} else {
		echo "Vous avez la possibilit d'importer une liste d'auteurs (le fichier est intitul annuaire.csv) afin d'viter de les saisir manuellement. Une fois que vous aurez tlcharg ce fichier sur le prsent site, vous pourrez choisir le statut par dfaut qui sera affect  ces auteurs ('visiteur', 'rdacteur', etc.). Vous pourrez bien sr modifier ultrieurement le statut d'un auteur particulier, toutefois, il est recommand de choisir le statut qui correspond au plus grand nombre d'auteurs. Le login par dfaut sera 'prenom.nom' (la partie de l'adresse lectronique situe  gauche de l'arobase). Le mot de passe par dfaut sera le nom de l'auteur (tel qu'il figure dans son adresse lectronique) suivi de plusieurs caractres que vous pourrez choisir OU BIEN les mots de passe seront gnrs automatiquement (dans ce cas <font color='red'>il est <B>impratif</B> de noter ou d'imprimer les mots de passe dans la liste qui s'affiche  la fin de l'importation, car c'est le seul moment o ils seront visibles</font>). Il est <B>indispensable</B> de demander aux utilisateurs de modifier ensuite leur mot de passe. Si un auteur a dj t cre, il ne sera pas import (la vrification porte sur l'adresse lectronique).<P align='justify'><B>Il est impratif d'utiliser un fichier qui soit intitul 'annuaire.csv' et qui respecte la structure suivante </B> (dans le cas  contraire, les rsultats seront imprvisibles et vous devrez mettre  la poubelle un par un les auteurs imports) : <br>".'"Prnom","Nom","Messagerie"<br>'.'"Yves","Montand","yves.montand@gmail.com"<br>'.'"Jean","Dupond","jean.dupond@yahoo.fr"<br>&nbsp;<br>La premire ligne du fichier contient la dfinition des en-ttes<br>';
	}
	echo "</FONT>";

	fin_boite_info();

//--------- Debut ajout CI (version CAS) -----
	if (cilire_config("cicas")=="oui") {
		// Avertissement en cas d'authentification CAS
		echo "<BR>";
		debut_boite_info();
		echo "<FONT FACE='Georgia,Garamond,Times,serif' SIZE='2'>
		<P align='center'><B>"._T('avis_attention')."</B><P align='justify'>
		<img src='img_pack/warning.gif' alt='' width='48' height='48' align='right'>";
		echo "<b>L'authentification est ralise par Cerbre / CAS. Aussi les logins et les mots de passe gnrs lors de l'importation ne seront pas utiliss.</b> En effet, ce sont les logins et les mots de passe de Cerbre / CAS qui seront utiliss pour l'authentification.\n";
		echo "</FONT>";
		fin_boite_info();
	}	
//--------- Fin ajout CI ---------------------	
	
	ci_afficher_boite_upload_auteurs();
	echo "</TD></TR>";
	echo "<TR><TD>&nbsp;</TD></TR>";
	echo "</TABLE>\n";
}	


fin_page();
//------Fin ajout CI ------------

?>