<?php

// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_GISEH_INC_ARI")) return;
define("_ECRIRE_GISEH_INC_ARI", "1");


//--------- Debut ajout CI (ec) ---------------------
function ci_droitauteur($cidroit, $valeur=false){
	global $connect_id_auteur,$connect_statut;
	$return=false;

	if ($cidroit){
		$ciquery = "SELECT pgp FROM spip_auteurs WHERE id_auteur='$connect_id_auteur'";
		$ciresult = spip_query($ciquery);
		if ($cirow = spip_fetch_array($ciresult)) {
			if ($valeur){			
				if (ci_lirepgp($cirow["pgp"],$cidroit)==$valeur){
					$return=true;
				}
			} else {
				if ($cidroit=='eccma') {
					if ($connect_statut == '0minirezo') {	// scurit
						if (ci_lirepgp($cirow["pgp"],$cidroit)==$cidroit){
							$return=true;
						} elseif (ci_lirepgp($cirow["pgp"],'ecadminsite')=='ecadminsite'){
							// un ecadminsite est galement eccma
							$return=true;
						}	
					}	
				} else {
					if (ci_lirepgp($cirow["pgp"],$cidroit)==$cidroit){
						$return=true;
					}
				}	
			}		
		}
	}

	return $return;
}

function ci_droit_id_auteur($id_auteur, $cidroit, $valeur=false){
	$return=false;

	if ($cidroit AND $id_auteur){
		$ciquery = "SELECT pgp FROM spip_auteurs WHERE id_auteur='$id_auteur'";
		$ciresult = spip_query($ciquery);
		if ($cirow = spip_fetch_array($ciresult)) {
			if ($valeur){			
				if (ci_lirepgp($cirow["pgp"],$cidroit)==$valeur){
					$return=true;
				}
			} else {	
				if (ci_lirepgp($cirow["pgp"],$cidroit)==$cidroit){
					$return=true;
				}
			}		
		}
	}

	return $return;
}

function ci_ari($ci_id_rub){
	$retour = false;
	$idmotari=ci_idmotari();	
	$query_ari = "SELECT id_rubrique FROM spip_mots_rubriques WHERE id_rubrique=".$ci_id_rub." AND id_mot IN ".$idmotari;
	$result_ari = spip_query($query_ari);

	if (spip_num_rows($result_ari)>0){
		$retour = true;
	}
	return $retour;
}

function ci_ar($ci_id_rub){
	$retour = false;
	$idmotar=ci_idmotar();
	$query_ar = "SELECT id_rubrique FROM spip_mots_rubriques WHERE id_rubrique=".$ci_id_rub." AND id_mot IN ".$idmotar;
	$result_ar = spip_query($query_ar);

	if (spip_num_rows($result_ar)>0){
		$retour = true;
	}
	
	return $retour;
}

function ci_ari_heritage($ci_id_rub){

	$retour = false;
	$idmotari=ci_idmotari();	
	$query_ari = "SELECT id_rubrique FROM spip_mots_rubriques WHERE id_rubrique=".$ci_id_rub." AND id_mot IN ".$idmotari;
	$result_ari = spip_query($query_ari);

	if (spip_num_rows($result_ari)==0){
		$ciparents=ci_parents($ci_id_rub);
		if($ciparents){
			$ci_liste_parents = "( ".implode(", ",$ciparents).")";
			
			$query_parent = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_rubrique IN ".$ci_liste_parents." AND lien_mot.id_mot=mots.id_mot AND mots.titre='_acces_indiv'";
			$result_parent = spip_query($query_parent);

			if (spip_num_rows($result_parent)>0) {
				$retour = true;
			}			
		}	
	}
	
	return $retour;
}

function ci_ar_heritage($ci_id_rub){
	
	$retour = false;
	$idmotar=ci_idmotar();
	$query_ar = "SELECT id_rubrique FROM spip_mots_rubriques WHERE id_rubrique=".$ci_id_rub." AND id_mot IN ".$idmotar;
	$result_ar = spip_query($query_ar);

	if (spip_num_rows($result_ar)==0){

		$ciparents=ci_parents($ci_id_rub);
		if($ciparents){
			$ci_liste_parents = "( ".implode(", ",$ciparents).")";
			
			$query_parent = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_rubrique IN ".$ci_liste_parents." AND lien_mot.id_mot=mots.id_mot AND mots.titre='_acces_restreint'";
			$result_parent = spip_query($query_parent);

			if (spip_num_rows($result_parent)>0) {
				$retour = true;
			}			
		}	
	}
	
	return $retour;
}


function ci_tableau_ari_sansheritage() {

	// tableau des rubriques EC sans heritage
	$ci_tabrubarish=array();
	
	$idmotari=ci_idmotari();

	$query_ari = "SELECT id_rubrique FROM spip_mots_rubriques WHERE id_mot IN ".$idmotari." GROUP BY id_rubrique";
	$result_ari = spip_query($query_ari);
	$ci_tabrubarish=array();
	if (@spip_num_rows($result_ari) > 0) {
		// rubriques EC (sans hritage)
		while ($row_arish = spip_fetch_array($result_ari)) {
			$id_rubriquesh = $row_arish['id_rubrique'];
			if ($id_rubriquesh!=0) {
				$ci_tabrubarish[$id_rubriquesh] = $id_rubriquesh;
			}	
		}
	}	

	return $ci_tabrubarish;
}


function ci_tableau_ari_heritage() {

	// tableau des rubriques EC avec heritage
	$ci_tabrubarih=array();

	$idmotari=ci_idmotari();
	
	$query_admin = "SELECT id_rubrique FROM spip_mots_rubriques WHERE id_mot IN ".$idmotari." GROUP BY id_rubrique";
	$result_admin = spip_query($query_admin);

	if ($result_admin) {
		for (;;) {
			$r = '';
			while ($row_admin = spip_fetch_array($result_admin)) {
				$id_rubrique = $row_admin['id_rubrique'];
				$r[] = $id_rubrique;
				$ci_tabrubarih[$id_rubrique] = $id_rubrique;
			}
			if (!$r) break;
			$r = join(',', $r);
			$query_admin = "SELECT id_rubrique FROM spip_rubriques WHERE id_parent IN ($r) AND id_rubrique NOT IN ($r)";
		 	$result_admin = spip_query($query_admin);
		 }
	}
	
	return $ci_tabrubarih;
}

function ci_tableau_rub_auteur_sansheritage($idauteur) {

	// Rubriques affectes  l'auteur (sans hritage)
	$ci_tabrubauteursh=array();

	$query_admin = "SELECT id_rubrique FROM spip_auteurs_rubriques WHERE id_auteur=$idauteur AND id_rubrique!='0'";
	$result_admin = spip_query($query_admin);

	if ($result_admin) {
		while ($row_auteur = spip_fetch_array($result_admin)) {
			$id_rubauteur = $row_auteur['id_rubrique'];
			$ci_tabrubauteursh[$id_rubauteur] = $id_rubauteur;
		}
	}	

	return $ci_tabrubauteursh;
}


function ci_tableau_ec_auteur_heritage($idauteur,$cirubari='(0)') {
// liste des EC auxquels la personne a droit 

//	$idmotari=ci_idmotari();
	$ci_tabecauteur=array();

	if ($cirubari){
		$query_ari = "SELECT id_rubrique FROM spip_auteurs_rubriques WHERE id_auteur=".$idauteur." AND id_rubrique IN ".$cirubari." GROUP BY id_rubrique";
		$result_admin = spip_query($query_ari);
		
		if ($result_admin) {
			for (;;) {
				$r = '';
				while ($row_admin = spip_fetch_array($result_admin)) {
					$id_rubrique = $row_admin['id_rubrique'];
					$r[] = $id_rubrique;
					$ci_tabecauteur[$id_rubrique] = $id_rubrique;
				}
				if (!$r) break;
				$r = join(',', $r);
				$query_admin = "SELECT id_rubrique FROM spip_rubriques WHERE id_parent IN ($r) AND id_rubrique NOT IN ($r)";
			 	$result_admin = spip_query($query_admin);
			 }
		}
	}
	
	return $ci_tabecauteur;
}


function ci_tableau_ascendants_ec_auteur($idauteur) {
// Ascendants EC des EC affectes  l'auteur (pour le site public )

	$tableau_rubrique=array();

	$ci_tabrubarih=ci_tableau_ari_heritage();

	// Rubriques affectes  l'auteur
	$query = "SELECT auteurs.id_rubrique, rubriques.id_parent FROM spip_auteurs_rubriques AS auteurs, spip_rubriques AS rubriques WHERE rubriques.id_rubrique=auteurs.id_rubrique AND auteurs.id_auteur=$idauteur AND auteurs.id_rubrique!='0'";
	$result = spip_query($query);

	if ($result) {
		for (;;) {
			$id_rub = '';
			while ($row = spip_fetch_array($result)) {
				$id_rub = $row["id_parent"];
				      // mmoriser les rubriques EC		
				      if (isset($ci_tabrubarih[$id_rub])) {
					$tableau_rubrique[$id_rub] = $id_rub;
				      }	
				
			}
			if (!$id_rub) break;
			$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=$id_rub";
		 	$result = spip_query($query);
		 }
	}	

	
	return $tableau_rubrique;
}



function ci_parents($id_rubrique) {
	$tableau_rubrique=array();
	if ($id_rubrique>0){
		$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=$id_rubrique";
		$result = spip_query($query);
	
		for (;;) {
			$id_rub = '';
			while ($row = spip_fetch_array($result)) {
				$id_rub = $row["id_parent"];
				$tableau_rubrique[$id_rub] = $id_rub;
			}
			if (!$id_rub) break;
			$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=$id_rub";
		 	$result = spip_query($query);
		 }
	}
	
	return $tableau_rubrique;	
}

function ci_descendance($id_rubrique) {
	$return="(0)";
	if ($id_rubrique>0){
		$query = "SELECT id_rubrique FROM spip_rubriques WHERE id_rubrique=$id_rubrique";
		$result = spip_query($query);
	
		for (;;) {
			$r = '';
			while ($row = spip_fetch_array($result)) {
				$id_rubrique = $row['id_rubrique'];
				$r[] = $id_rubrique;
				$tableau_rubrique[$id_rubrique] = $id_rubrique;
			}
			if (!$r) break;
			$r = join(',', $r);
			$query = "SELECT id_rubrique FROM spip_rubriques WHERE id_parent IN ($r) AND id_rubrique NOT IN ($r)";
		 	$result = spip_query($query);
		 }
		    if ($tableau_rubrique){
		        $return = "( ".implode(", ",$tableau_rubrique).", 0)";
		    }
	}
	
	return $return;	
}


function ci_ascendance($id_rubrique) {
	$return="(0)";
	if ($id_rubrique>0){
		$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=$id_rubrique";
		$result = spip_query($query);
	
		for (;;) {
			$id_rub = '';
			while ($row = spip_fetch_array($result)) {
				$id_rub = $row["id_parent"];
				$tableau_rubrique[$id_rub] = $id_rub;
			}
			if (!$id_rub) break;
			$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=$id_rub";
		 	$result = spip_query($query);
		 }
		    if ($tableau_rubrique){
		        $return = "( ".implode(", ",$tableau_rubrique).", 0)";
		    }
	}
	
	return $return;	
}


function ci_ascendanceari($id_rubrique) {
	$return="(0)";
	if ($id_rubrique>0){
		
		$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=$id_rubrique";
		$result = spip_query($query);
	
		for (;;) {
			$id_rub = '';
			while ($row = spip_fetch_array($result)) {
				$id_rub = $row["id_parent"];
				if (ci_ari($id_rub)) $tableau_rubrique[$id_rub] = $id_rub;
			}
			if (!$id_rub) break;
			$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique=$id_rub";
		 	$result = spip_query($query);
		 }
		    if ($tableau_rubrique){
		        $return = "( ".implode(", ",$tableau_rubrique).", 0)";
		    }
	}
	
	return $return;	
}


function ci_idmotari() {
// il faut tenir compte du cas o il existe plusieurs mots '_acces_indiv'
	static $ci_idmotari;

	if (!$ci_idmotari) {
		$ci_idmotari="(0)";
		$query = "SELECT id_mot FROM spip_mots WHERE titre='_acces_indiv' ORDER BY id_mot";
		$result = spip_query($query);
	
		while ($row = spip_fetch_array($result)) {
			$citableau[] = $row['id_mot'];
		}
		if ($citableau) {
			if(is_array($citableau)) $ci_idmotari = "( ".implode(", ",$citableau).", 0)";
		}		 
		if (!$ci_idmotari) $ci_idmotari="(0)";
	}
	return $ci_idmotari;	
}	

function ci_idmotar() {
// il faut tenir compte du cas o il existe plusieurs mots '_acces_restreint'

	static $ci_idmotar;

	if (!$ci_idmotar) {
		$query = "SELECT id_mot FROM spip_mots WHERE titre='_acces_restreint' ORDER BY id_mot";
		$result = spip_query($query);
	
		while ($row = spip_fetch_array($result)) {
			$citableau[] = $row['id_mot'];
		}
		if ($citableau) {
			if(is_array($citableau)) $ci_idmotar = "( ".implode(", ",$citableau).", 0)";
		}		 
		if (!$ci_idmotar) $ci_idmotar="(0)";
	}		
	return $ci_idmotar;	
}	



function ci_tableau_email($id_rubrique) {

	$tableau_email=array();
	
	if (ci_ari($id_rubrique) OR ci_ari_heritage($id_rubrique)) {
//----------------- Debut ajout CI (statut ciredval) ---------------------------
//	$ci_where = " AND auteurs.statut IN ('0minirezo', '1comite')";
	$ci_where = " AND auteurs.statut IN ('0minirezo', '1comite', 'ciredval', '6forum')";
//----------------- Fin ajout CI -----------------------------------------------------
		// droits par hritage
		$cilisteparents=ci_ascendanceari($id_rubrique);
		if ($cilisteparents!="(0)") {
	
			$query = "SELECT auteurs.* FROM spip_auteurs AS auteurs, spip_auteurs_rubriques AS lien WHERE lien.id_rubrique IN $cilisteparents AND auteurs.id_auteur=lien.id_auteur ".$ci_where." ORDER BY nom";
			$result = spip_query($query);
			while ($row = spip_fetch_array($result)) {
				$tableau_email[$row["id_auteur"]] = $row;
			}	
		}
		
		// droits par affectation directe
		$query = "SELECT auteurs.* FROM spip_auteurs AS auteurs, spip_auteurs_rubriques$table AS lien WHERE lien.id_rubrique=$id_rubrique AND auteurs.id_auteur=lien.id_auteur ".$ci_where." ORDER BY nom";
		$result = spip_query($query);
		
		while ($row = spip_fetch_array($result)) {
			$ciidauteur = $row["id_auteur"];
			if (!isset($tableau_email[$ciidauteur])) {
				$tableau_email[$ciidauteur] = $row;
			}	
		}
	}
		
	return $tableau_email;		
}

function ci_lirepgp($texte,$cle){
	$value=false;
	if($texte AND $cle){	
		$tagdebut="<".$cle.">";
		$posdebut = strpos($texte, $tagdebut);
		if ($posdebut === false){
			$value=false;
		} else {	 		
			$tagfin="</".$cle.">";
			$posdebut = $posdebut + strlen($cle) +2;
			$longval = strpos($texte, $tagfin)-$posdebut;
			$value=substr($texte,$posdebut,$longval);
		}
	}	
	return $value;
}

function ci_majpgp($texte,$cle,$newvalue){
	$newtexte='';
	if (!$texte) $texte='';
	if($cle){	
		$tagdebut="<".$cle.">";
		$tagfin="</".$cle.">";
		$oldval=ci_lirepgp($texte,$cle);
		
		if ($oldval){
			$oldval=$tagdebut.$oldval.$tagfin;
			$newval=$tagdebut.$newvalue.$tagfin;
			$newtexte=str_replace($oldval,$newval,$texte);
		} else {
			$posdebut = strpos($texte, $tagdebut);
			if ($posdebut === false){
				$newtexte=$texte.$tagdebut.$newvalue.$tagfin;
			} else {		
				// pas de valeur mais les tags existent
				$oldval=$tagdebut.$tagfin;
				$newval=$tagdebut.$newvalue.$tagfin;
				$newtexte=str_replace($oldval,$newval,$texte);			
			}	
		}
	}
	return $newtexte;
}

//--------- Fin ajout CI ---------------------

//---------- Debut ajout CI (optimisation du menu) --------------------
// Une balise ajoute  SPIP contient l'appel  cette fonction
// cette fonction permet de construire le contenu du menu dynamique 
function ciequip_menu($Pile,$SP) {
// le contenu de $ciliste_rubriques varie si l'utilisateur est authentifi ou non
global $var_preview, $ciliste_rubriques,$ciliste_rubdusite,$ciliste_rubprepa;


	$old_lang = $GLOBALS['spip_lang'];
	if (!$GLOBALS['forcer_lang'])
 		$GLOBALS['spip_lang'] = ($x = $Pile[$SP]['lang']) ? $x : $old_lang;

	$citexte ="";
	$cin1n2=array();
	$cin2titre=array();
	$cin2=array();
	$cin2n3=array();
	$cin3titre=array();
	$niv3existe=false;
	$cirubmasque=array();
	$masqueexiste=false;
    	$ci_menu_1niveau=false;
    	$ci_menu_2niveau=false;
    	$ci_menu_3niveau=true;
    	
	// Nombre de niveau paramtrs
    	$ci_menu_niveau = lire_meta("equip_menu_niveau");
	if ($ci_menu_niveau) {
		if ($ci_menu_niveau=="1") {
		    	$ci_menu_1niveau=true;
		    	$ci_menu_2niveau=false;
		    	$ci_menu_3niveau=false;	
		} elseif ($ci_menu_niveau=="2") {
		    	$ci_menu_1niveau=false;
		    	$ci_menu_2niveau=true;
		    	$ci_menu_3niveau=false;	
		}		
	}
	
	if ($ci_menu_2niveau OR $ci_menu_3niveau) {
	
		// les rubriques masques
	    	$querym = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_mot=mots.id_mot AND mots.titre='_masquer_dans_menu_dynamique'";
		$resultm = @spip_query($querym);
		
		if ($resultm) {
			$masqueexiste=true;
			while ($rowm = @spip_fetch_array($resultm)) {
			                    $cirubmasque[]=$rowm['id_rubrique'];
			}
		}	
		
		// les secteurs (rubriques de niveau 1)
		if ($var_preview )  {
		    	$query = "SELECT rubriques.id_rubrique,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent=0 AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY num";
		} else {
		    	$query = "SELECT rubriques.id_rubrique,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent=0 AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY num";
		}
		if (cilire_config('cimultisites')=="oui") $query = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query);
		$result = @spip_query($query);
		
		if ($result) {
			while ($row = @spip_fetch_array($result)) {
				if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) $cisecteurs[] = $row['id_rubrique'];
			}
			
			$cilistesecteurs="(0)";
			if (isset($cisecteurs)) $cilistesecteurs="( ".implode(", ",$cisecteurs).")";
			
			// les rubriques de niveau 2
			if ($var_preview )  {
			    	$query2 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent  IN ".$cilistesecteurs." AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY rubriques.id_parent, num";
			} else {
			    	$query2 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent IN ".$cilistesecteurs." AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY rubriques.id_parent, num";
			}
			if (cilire_config('cimultisites')=="oui") $query2 = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query2);
			$result2 = @spip_query($query2);
			
			if ($result2) {
				while ($row = @spip_fetch_array($result2)) {
					if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) {
						$cin1n2[$row['id_rubrique']] = $row['id_parent'];
						$cin2titre[$row['id_rubrique']] = $row['titre'];
						$cin2[]=$row['id_rubrique'];
					}     
				}
	
				$cilisten2="( ".implode(", ",$cin2).")";
	
				if ($ci_menu_3niveau AND $cilisten2!="( )") {
					// les rubriques de niveau 3
					if ($var_preview )  {
					    	$query3 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent  IN ".$cilisten2." AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY rubriques.id_parent, num";
					} else {
					    	$query3 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent IN ".$cilisten2." AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY rubriques.id_parent, num";
					}
					if (cilire_config('cimultisites')=="oui") $query3 = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query3);
					$result3 = @spip_query($query3);
					
					if ($result3) {
						$niv3existe=true;
						while ($row = @spip_fetch_array($result3)) {
							if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) {
								$cin2n3[$row['id_rubrique']] = $row['id_parent'];
								$cin3titre[$row['id_rubrique']] = $row['titre'];
							}
						}
					}		
				}
	
				$secteur=0;
				reset($cin1n2);					
				reset($cin2n3);					
				while (list($rubn2, $rubn1) = each($cin1n2)) {
					if ($rubn1!=$secteur) {
						if ($secteur!=0) $citexte .='<\/div>';
						$citexte .='<div id="menuRub'.$rubn1.'" class="menu" onmouseover="menuMouseover(event)">';
						$secteur=$rubn1;
					}
					if ($niv3existe AND in_array($rubn2,$cin2n3)) {
						$citexte .='<a class="menuItem" href="'.htmlspecialchars(generer_url_rubrique($rubn2)).'"   onmouseover="menuItemMouseover(event,\\\'menuRub'.$rubn2.'\\\');"><span class="menuItemText">'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin2titre[$rubn2]))))).'<\/span><span class="menuItemArrow">&#9654;<\/span><\/a>';
					} else {
						$citexte .='<a class="menuItem" href="'.htmlspecialchars(generer_url_rubrique($rubn2)).'">'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin2titre[$rubn2]))))).'<\/a>';
		
					}				
				}				
				if ($citexte) $citexte .='<\/div>';
				
				if ($niv3existe) {
					$citexten3="";
					$rubn1=0;
					reset($cin2n3);					
					while (list($rubn3, $rubn2) = each($cin2n3)) {
						if ($rubn2!=$rubn1) {
							if ($rubn1!=0) $citexten3 .='<\/div>';
							$citexten3 .='<div id="menuRub'.$rubn2.'" class="menu">';
							$rubn1=$rubn2;
						}
						$citexten3 .='<a class="menuItem" href="'.htmlspecialchars(generer_url_rubrique($rubn3)).'">'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin3titre[$rubn3]))))).'<\/a>';
			
					}				
					if ($citexten3) $citexten3 .='<\/div>';
					
					
					$citexte .=$citexten3;
				}		
			}		
		}
	}	
	
	$GLOBALS['spip_lang'] = $old_lang;

	return  $citexte;
	
}	

//---------- Fin ajout CI --------------------

//--------------------- Debut ajout CI (ec) -----
function civerifidmot($ciidmot,$table, $id_objet, $action){
	global $connect_id_auteur;
	global $connect_statut;
	global $connect_toutes_rubriques;
	$return=true;	

	if($ciidmot) {
		$ciquery = "SELECT * FROM spip_mots WHERE id_mot = $ciidmot AND titre IN ('_acces_indiv','_chat') ";
		$ciresult = spip_query($ciquery);
		if (spip_num_rows($ciresult)>0) {
			$return=false;	
			if ((ci_droitauteur('eccma') OR ci_droitauteur('ecadminsite')) AND ($connect_statut=='0minirezo')){
				$return=true;	
			}		
			//--------------------- Debut ajout CI (varianteec) -----
			if ($table=='rubriques'){
				if(!ci_connect_eccma($id_objet)) $return=false;
			}

			// si ci_connect_eccma alors on doit pouvoir crer un chat 
			if ($table=='articles'){
				$ci_id_rubrique = 0;
				$ciquery = "SELECT id_rubrique FROM spip_articles WHERE id_article = ".intval($id_objet);
				$ciresult = spip_query($ciquery);
				while ($row = spip_fetch_array($ciresult)) {
					$ci_id_rubrique = $row['id_rubrique'];
				}
/*				
				$row = spip_abstract_fetsel(array('id_rubrique'),
						array('spip_articles'),
						array("id_article=" . intval($id_objet)));
				$ci_id_rubrique = $row['id_rubrique'];
*/
				if($ci_id_rubrique>0 AND ci_connect_eccma($ci_id_rubrique)) {
					while($row = spip_fetch_array($ciresult)) {
						if ($row['titre']=='_chat') $return=true;
					}
				}
			}
			
			// Ne pas mettre en EC une rubrique qui contient un EC dans son arborescence
			if ($table=='rubriques' AND $action='insert'){
				global $ci_ec_interdit;
				$ciliste_rubriques=ci_descendance($id_objet);	
		
				$query_ari = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_rubrique IN ".$ciliste_rubriques." AND lien_mot.id_mot=mots.id_mot AND mots.titre='_acces_indiv'";
				$result_ari = spip_query($query_ari);
				
				if (spip_num_rows($result_ari)>0){
					$ci_ec_interdit=true;
					$return=false;	
				}	
			}	
			//--------------------- Fin ajout CI ------------------
		}

		
		$ciquery = "SELECT * FROM spip_mots WHERE id_mot = $ciidmot AND titre IN ('_questionner','_questano','_signature') ";
		$ciresult = spip_query($ciquery);
		while ($row_autres = spip_fetch_array($ciresult)) {
			$return=false;	
			$le_cimot = $row_autres['titre'];
			If (($le_cimot=='_questionner' AND $connect_statut == '0minirezo') OR (($le_cimot=='_questano' OR $le_cimot=='_signature') AND ($connect_statut == '0minirezo' AND $connect_toutes_rubriques))) {		
				$return=true;
			}		
		}
		
	}
	return $return;
}					

function cieccreateur($ciidmot,$id_objet){
// lorsqu'un auteur cre un EC, cette fonction lui affecte la rubrique en question	
	global $connect_id_auteur;
	$return=false;	
	$accesindiv=false;
	$affecter=false;
	if($ciidmot) {
		$ciquery = "SELECT * FROM spip_mots WHERE id_mot = $ciidmot AND titre='_acces_indiv'";
		$ciresult = spip_query($ciquery);
		if (spip_num_rows($ciresult)>0) {
			$accesindiv=true;	
		}
		if ($accesindiv) {
			$query2 = "SELECT id_rubrique FROM spip_auteurs_rubriques WHERE id_auteur=$connect_id_auteur AND id_rubrique=$id_objet";
			$result2 = spip_query($query2);			
			if (spip_num_rows($result2)>0) {
				$affecter=false;	
			} else {
				$affecter=true;	
			}
			if ($affecter) {
				$query3 = "INSERT INTO spip_auteurs_rubriques (id_auteur,id_rubrique) VALUES($connect_id_auteur,$id_objet)";
				$result3 = spip_query($query3);
				if (mysql_affected_rows()>0) {
					$return=true;
				}	
			}				
		}
	}
	return $return;
}


//--------------------- Fin ajout CI -----				


//---------- Debut ajout CI (varianteec) -----
function ciboutonprotection($id_rubrique){
	if ($id_rubrique!=0) {
		echo "<form action='_giseh_droits.php3' method='get'>";
		debut_cadre_enfonce("mot-cle-24.gif", false, "", 'Restreindre ou non l\'accs sur le site public');
		echo "<table><tr><td>";
		echo "<div STYLE='width:250px;padding:0px; float: none;font-size:11px; font-family:Sans,sans-serif;'>".cilibprotectionrub($id_rubrique)."</div>";
		echo "</td><td>";
		echo "<div style='text-align:right;'><input type='submit' name='Submit' style='width:200px;font-size:10px;background-color: #85909A;background-position: center bottom; float: none;color: #FFFFFF;' value=\"Modifier la protection ou grer les droits\"></div>\n";
		echo "</td></tr></table>";
		fin_cadre_enfonce();			
		echo "<input type='Hidden' name='id_rubrique' value=$id_rubrique>\n";
		echo "</form>";
	}
}

function cilibprotectionrub($id_rubrique){

	if ($id_rubrique!=0 AND (cilire_config('ciautorisear')=="oui")) {
			$cilibelle=cilibprotection(ciidprotection($id_rubrique));
	}	

	return $cilibelle;
}

function ciidprotection($id_rubrique){

	$ciid="_acces_libre";		
	
	if ($id_rubrique!=0 AND (cilire_config('ciautorisear')=="oui")) {
		if (ci_ari($id_rubrique)) {
			$ciid="_acces_indiv";
		} elseif (ci_ar($id_rubrique)) {
			$ciid="_acces_restreint";
		} elseif (ci_ari_heritage($id_rubrique)) {
			$ciid="_acces_indiv_heritage";
		} elseif (ci_ar_heritage($id_rubrique)) {
			$ciid="_acces_restreint_heritage";
		}
	}	

	return $ciid;
}

function cilibprotection($ciid){

	switch ($ciid) {
	case "_acces_indiv":
		$cilibelle="Cette rubrique est un espace collaboratif (selon les droits d'accs).";
		break;
	case "_acces_restreint":
		$cilibelle="Cette rubrique est en accs restreint sur le site public (aux personnes authentifies).";
		break;
	case "_acces_indiv_heritage":
		$cilibelle="Par hritage d'une rubrique parente, cette rubrique est un espace collaboratif (selon les droits d'accs).";
		break;
	case "_acces_restreint_heritage":
		$cilibelle="Par hritage d'une rubrique parente, cette rubrique est en accs restreint sur le site public (aux personnes authentifies).";
		break;
	default:
		$cilibelle="Cette rubrique est en accs libre sur le site public.";		
		break;
	}
	
	return $cilibelle;
}

function cilibstatut() {
	return array("1comite"=>"Rdacteur",
						"ciredval"=>"Rdacteur publieur",
						"0minirezo"=>"Gre la rubrique",
						"eccma"=>"Gre la rubrique et ses droits d'accs",
						"6forum"=>"Visiteur");
}

function ciimplode_with_key($assoc, $inglue = '=', $outglue = '&')
{
   $return = "";
   if (isset($assoc)) {
	   foreach ($assoc as $tk => $tv) $return .= $outglue.$tk.$inglue.$tv;
	   if($return) $return=substr($return,1);
   }	   
   return $return;
}

function ci_suppr_droit($id_rubrique) {
	$return=false;
	
	if ($id_rubrique>0) {
		$query="DELETE FROM spip_ci_droit_rubriques WHERE id_rubrique=".$id_rubrique;
		spip_query($query);
		if (mysql_affected_rows()>0) $return=true;
	}

	return $return;
}
//--------- Fin ajout CI -----

//---------- Debut ajout CI (optimisation du menu) --------------------
// Une balise ajoute  SPIP contient l'appel  cette fonction
// cette fonction permet de contruire le contenu du menu dynamique
// menu vertical avec mise en gras de la rubrique en cours 
function ciequip_menu_vertical($Pile,$SP) {
// le contenu de $ciliste_rubriques varie si l'utilisateur est authentifi ou non
global $var_preview, $ciliste_rubriques,$ciliste_rubdusite,$ciliste_rubprepa;


	$old_lang = $GLOBALS['spip_lang'];
	if (!$GLOBALS['forcer_lang'])
 		$GLOBALS['spip_lang'] = ($x = $Pile[$SP]['lang']) ? $x : $old_lang;

 	$cicurrent=0;
 	if (isset($Pile[$SP]['id_rubrique'])) $cicurrent=$Pile[$SP]['id_rubrique'];
	$cicurrents=array();
 	$ciclassul="hide";
	$citexte ="";
	$citexte2 ="";
	$citexte3 ="";
	$cin1titre=array();
	$cin1=array();
	$cin1n2=array();
	$cin2titre=array();
	$cin2=array();
	$cin2n3=array();
	$cin3titre=array();
	$niv3existe=false;
	$cirubmasque=array();
	$masqueexiste=false;
    	$ci_menu_1niveau=false;
    	$ci_menu_2niveau=false;
    	$ci_menu_3niveau=true;
    	
	// Nombre de niveau paramtrs
    	$ci_menu_niveau = lire_meta("equip_menu_niveau");
	if ($ci_menu_niveau) {
		if ($ci_menu_niveau=="1") {
		    	$ci_menu_1niveau=true;
		    	$ci_menu_2niveau=false;
		    	$ci_menu_3niveau=false;	
		} elseif ($ci_menu_niveau=="2") {
		    	$ci_menu_1niveau=false;
		    	$ci_menu_2niveau=true;
		    	$ci_menu_3niveau=false;	
		}		
	}
	
	
	
	// les rubriques masques
    	$querym = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_mot=mots.id_mot AND mots.titre='_masquer_dans_menu_dynamique'";
	$resultm = @spip_query($querym);
	
	if ($resultm) {
		$masqueexiste=true;
		while ($rowm = @spip_fetch_array($resultm)) {
		                    $cirubmasque[]=$rowm['id_rubrique'];
		}
	}	
	
	// les secteurs (rubriques de niveau 1)
	if ($var_preview )  {
	    	$query = "SELECT rubriques.id_rubrique,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent=0 AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY num";
	} else {
	    	$query = "SELECT rubriques.id_rubrique,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent=0 AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY num";
	}
	if (cilire_config('cimultisites')=="oui") $query = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query);
	$result = @spip_query($query);
	
	if ($result) {
		while ($row = @spip_fetch_array($result)) {
			if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) {
				$cin1[] = $row['id_rubrique'];
				$cin1titre[$row['id_rubrique']] = $row['titre'];
			}
		}
		
		$cilistesecteurs="(0)";
		if (isset($cin1)) $cilistesecteurs="( ".implode(", ",$cin1).")";
		
		
		
		if ($ci_menu_2niveau OR $ci_menu_3niveau) {
		
			// les rubriques de niveau 2
			if ($var_preview )  {
			    	$query2 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent  IN ".$cilistesecteurs." AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY rubriques.id_parent, num";
			} else {
			    	$query2 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent IN ".$cilistesecteurs." AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY rubriques.id_parent, num";
			}
			if (cilire_config('cimultisites')=="oui") $query2 = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query2);
			$result2 = @spip_query($query2);
			
			if ($result2) {
				while ($row = @spip_fetch_array($result2)) {
					if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) {
						$cin1n2[$row['id_rubrique']] = $row['id_parent'];
						$cin2titre[$row['id_rubrique']] = $row['titre'];
						$cin2[]=$row['id_rubrique'];
					}     
				}
	
				$cilisten2="( ".implode(", ",$cin2).")";
	
				if ($ci_menu_3niveau AND $cilisten2!="( )") {
					// les rubriques de niveau 3
					if ($var_preview )  {
					    	$query3 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent  IN ".$cilisten2." AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY rubriques.id_parent, num";
					} else {
					    	$query3 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent IN ".$cilisten2." AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY rubriques.id_parent, num";
					}
					if (cilire_config('cimultisites')=="oui") $query3 = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query3);
					$result3 = @spip_query($query3);
					
					if ($result3) {
						$niv3existe=true;
						while ($row = @spip_fetch_array($result3)) {
							if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) {
								$cin2n3[$row['id_rubrique']] = $row['id_parent'];
								$cin3titre[$row['id_rubrique']] = $row['titre'];
							}
						}
					}		
				}
			}

			$cicurrentn4ouplus=false;
			// le dclenchement du show des ul
			if (in_array($cicurrent,$cin1)) {
				// ne rien faire
			} elseif (isset($cin1n2[$cicurrent])) {	
//				$cicurrents[]=$cin1n2[$cicurrent];
			} elseif (isset($cin2n3[$cicurrent])) {	
//				$cicurrents[]=$cin2n3[$cicurrent];
//				if (isset($cin1n2[$cin2n3[$cicurrent]])) $cicurrents[]=$cin1n2[$cin2n3[$cicurrent]];			
			} else {
				$cicurrentn4ouplus=true;				
			}
			
			$cicurrents=ci_parents($cicurrent);
			$cicurrents[]=$cicurrent;			
		}
		
		
		$secteur=0;
		reset($cin1);
		$citexte .='<ul class="pde">';

		while (list(, $rubsecteur) = each($cin1)) {
			$citexte .='<li><a href="'.htmlspecialchars(generer_url_rubrique($rubsecteur)).'"';
			if ($rubsecteur==$cicurrent) {
				$citexte .=' class="LienMenu1on"';
			} else {
				$citexte .=' class="LienMenu1"';
			}
			$citexte .='>'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin1titre[$rubsecteur]))))).'</a>';
				
			if (($ci_menu_2niveau OR $ci_menu_3niveau) AND in_array($rubsecteur,$cin1n2)) {
//				$ciclassul="hide";
//				if (in_array($rubsecteur,$cicurrents)) $ciclassul="show";
				
//				$citexte .='<ul class="'.$ciclassul.'">';
				reset($cin1n2);
				$citexte2="";
				while (list($rubn2, $rubn1) = each($cin1n2)) {
					if ($rubn1==$rubsecteur) {
						if ($rubn2==$cicurrent) {
							$citexte2 .='<li><a href="'.htmlspecialchars(generer_url_rubrique($rubn2)).'"';
							$citexte2 .=' class="LienMenu2on"';
							$citexte2 .='>'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin2titre[$rubn2]))))).'</a>';
						} elseif (in_array($rubsecteur,$cicurrents)) {
							$citexte2 .='<li><a href="'.htmlspecialchars(generer_url_rubrique($rubn2)).'"';
							$citexte2 .=' class="LienMenu2"';
							$citexte2 .='>'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin2titre[$rubn2]))))).'</a>';
						}
												
						if ($citexte2) {					
							$citexte3="";					
							if ($ci_menu_3niveau AND in_array($rubn2,$cin2n3)) {
//								$ciclassul="hide";
//								if (in_array($rubn2,$cicurrents)) $ciclassul="show";
								
//								$citexte .='<ul class="'.$ciclassul.'">';
								reset($cin2n3);					
								while (list($rubn3, $rubniv2) = each($cin2n3)) {
									if ($rubn2==$rubniv2) {
										if ($rubn3==$cicurrent) {
											$citexte3 .='<li><a href="'.htmlspecialchars(generer_url_rubrique($rubn3)).'"';
											$citexte3 .=' class="LienMenu3on"';
											$citexte3 .='>'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin3titre[$rubn3]))))).'</a></li>';
										} elseif (in_array($rubn2,$cicurrents)) {
											$citexte3 .='<li><a href="'.htmlspecialchars(generer_url_rubrique($rubn3)).'"';
											if ($cicurrentn4ouplus AND in_array($rubn3,$cicurrents)) {
												$citexte3 .=' class="LienMenu3on"';
											} else {
												$citexte3 .=' class="LienMenu3"';
											}
											$citexte3 .='>'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin3titre[$rubn3]))))).'</a></li>';
										}	
									}
								}
//								$citexte .='</ul>';
							}
							$ciclassul="hide";
							if (in_array($rubn2,$cicurrents)) $ciclassul="show";
							if ($citexte3) {
								$citexte2 .='<ul class="'.$ciclassul.'">'.$citexte3.'</ul>'.'</li>';
							} else {
								$citexte2 .='</li>';
							}
						}
//						$citexte .='</li>';							
					}
				}		
//				$citexte .='</ul>';
				$ciclassul="hide";
				if (in_array($rubsecteur,$cicurrents)) $ciclassul="show";
				if ($citexte2) {
					$citexte .='<ul class="'.$ciclassul.'">'.$citexte2.'</ul>';
				}
						
			}
			$citexte .='</li>';
		} // fin du premier while
		
		$citexte .='</ul>';
		
	}
		
	
	$GLOBALS['spip_lang'] = $old_lang;

	return  $citexte;
	
}	

// Menu utilisant jquery
function ciequip_menu2($Pile,$SP) {
// le contenu de $ciliste_rubriques varie si l'utilisateur est authentifié ou non
global $var_preview, $ciliste_rubriques,$ciliste_rubdusite,$ciliste_rubprepa;


	$old_lang = $GLOBALS['spip_lang'];
	if (!$GLOBALS['forcer_lang'])
 		$GLOBALS['spip_lang'] = ($x = $Pile[$SP]['lang']) ? $x : $old_lang;

	$citexte ="";
	$cin1n2=array();
	$cin2titre=array();
	$cin2=array();
	$cin2n3=array();
	$cin3titre=array();
	$niv3existe=false;
	$cirubmasque=array();
	$masqueexiste=false;
    	$ci_menu_1niveau=false;
    	$ci_menu_2niveau=false;
    	$ci_menu_3niveau=true;
    	
	// Nombre de niveau paramétrés
    	$ci_menu_niveau = lire_meta("equip_menu_niveau");
	if ($ci_menu_niveau) {
		if ($ci_menu_niveau=="1") {
		    	$ci_menu_1niveau=true;
		    	$ci_menu_2niveau=false;
		    	$ci_menu_3niveau=false;	
		} elseif ($ci_menu_niveau=="2") {
		    	$ci_menu_1niveau=false;
		    	$ci_menu_2niveau=true;
		    	$ci_menu_3niveau=false;	
		}		
	}
	
	if ($ci_menu_2niveau OR $ci_menu_3niveau) {
	
		// les rubriques masquées
	    	$querym = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_mot=mots.id_mot AND mots.titre='_masquer_dans_menu_dynamique'";
		$resultm = @spip_query($querym);
		
		if ($resultm) {
			$masqueexiste=true;
			while ($rowm = @spip_fetch_array($resultm)) {
			                    $cirubmasque[]=$rowm['id_rubrique'];
			}
		}	
		
		// les secteurs (rubriques de niveau 1)
		if ($var_preview )  {
		    	$query = "SELECT rubriques.id_rubrique,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent=0 AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY num";
		} else {
		    	$query = "SELECT rubriques.id_rubrique,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent=0 AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY num";
		}
		if (cilire_config('cimultisites')=="oui") $query = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query);
		$result = @spip_query($query);
		
		if ($result) {
			while ($row = @spip_fetch_array($result)) {
				if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) $cisecteurs[] = $row['id_rubrique'];
			}
			
			$cilistesecteurs="(0)";
			if (isset($cisecteurs)) $cilistesecteurs="( ".implode(", ",$cisecteurs).")";
			
			// les rubriques de niveau 2
			if ($var_preview )  {
			    	$query2 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent  IN ".$cilistesecteurs." AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY rubriques.id_parent, num";
			} else {
			    	$query2 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent IN ".$cilistesecteurs." AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY rubriques.id_parent, num";
			}
			if (cilire_config('cimultisites')=="oui") $query2 = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query2);
			$result2 = @spip_query($query2);
			
			if ($result2) {
				while ($row = @spip_fetch_array($result2)) {
					if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) {
						$cin1n2[$row['id_rubrique']] = $row['id_parent'];
						$cin2titre[$row['id_rubrique']] = $row['titre'];
						$cin2[]=$row['id_rubrique'];
					}     
				}
	
				$cilisten2="( ".implode(", ",$cin2).")";
	
				if ($ci_menu_3niveau AND $cilisten2!="( )") {
					// les rubriques de niveau 3
					if ($var_preview )  {
					    	$query3 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent  IN ".$cilisten2." AND ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY rubriques.id_parent, num";
					} else {
					    	$query3 = "SELECT rubriques.id_rubrique,rubriques.id_parent,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_parent IN ".$cilisten2." AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY rubriques.id_parent, num";
					}
					if (cilire_config('cimultisites')=="oui") $query3 = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query3);
					$result3 = @spip_query($query3);
					
					if ($result3) {
						$niv3existe=true;
						while ($row = @spip_fetch_array($result3)) {
							if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) {
								$cin2n3[$row['id_rubrique']] = $row['id_parent'];
								$cin3titre[$row['id_rubrique']] = $row['titre'];
							}
						}
					}		
				}
	
				$secteur=0;
				reset($cin1n2);					
				reset($cin2n3);					
				while (list($rubn2, $rubn1) = each($cin1n2)) {
					if ($rubn1!=$secteur) {
						if ($secteur!=0) $citexte .='<\/div>';
						$citexte .='<div id="menuRub'.$rubn1.'" class="menu" ">';//onmouseover="menuMouseover(event)
						$secteur=$rubn1;
					}
					if ($niv3existe AND in_array($rubn2,$cin2n3)) {
						$citexte .='<span class="unItem" id="sRub'.$rubn2.'"><a class="menuItem plus" href="'.htmlspecialchars(generer_url_rubrique($rubn2)).'" id="Rub'.$rubn2.'">'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin2titre[$rubn2]))))).'<\/a><\/span>';//onmouseover="menuItemMouseover(this,event,\\\'menuRub'.$rubn2.'\\\');"
					} else {
						$citexte .='<span class="unItem"><a class="menuItem" href="'.htmlspecialchars(generer_url_rubrique($rubn2)).'">'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin2titre[$rubn2]))))).'<\/a><\/span>';
		
					}				
				}				
				if ($citexte) $citexte .='<\/div>';
				if ($niv3existe) {
					$citexten3="";
					$rubn1=0;
					reset($cin2n3);					
					while (list($rubn3, $rubn2) = each($cin2n3)) {
						if ($rubn2!=$rubn1) {
							if ($rubn1!=0) $citexten3 .='<\/div>';
							$citexten3 .='<div id="menuRub'.$rubn2.'" class="menu">';
							$rubn1=$rubn2;
						}
						$citexten3 .='<a class="menuItem" href="'.htmlspecialchars(generer_url_rubrique($rubn3)).'">'.texte_script(supprimer_numero(interdire_scripts(typo(trim($cin3titre[$rubn3]))))).'<\/a>';
			
					}				
					if ($citexten3) $citexten3 .='<\/div>';
					
					
					$citexte .=$citexten3;
				}		
			}		
		}
	}	
	
	$GLOBALS['spip_lang'] = $old_lang;

	return  $citexte;
	
}	


//---------- Fin ajout CI ------

//---------- Debut ajout CI (volumetrie rubrique) -------

// Une balise ajoute  SPIP contient l'appel  cette fonction
// cette fonction permet de construire le plan du site
function ciequip_plan($Pile,$SP) {

	global $citexteplan;
	global $ciarbo;
	
	$ciarbo = ci_arbo_plan();
	$citexteplan = '<ul class="plansite">';
	ci_enfantplan(0);
	$citexteplan .= '</ul>';
	
	return $citexteplan;  
}	

function ci_enfantplan($leparent){
	global $id_parent;
	global $id_rubrique;
	static $i = 0;
	global $ciarbo;
	global $citexteplan;
	
	$i++;
 	$citableau = $ciarbo["p".strval($leparent)];	
	 	
	 	
 	if ($citableau) {
		if ($i > 1)
	 		$citexteplan .= '<ul>';
		
	 	foreach($citableau as $row) {
			$my_rubrique=$row[0];
			$titre=$row[1];
		
			$ciclass = "";
	
			switch ($i) {
			case 1:
				$ciclass = "plansecteur";
				break;
			case 2:
				$ciclass = "planrubniv1";
				break;
			default:
				$ciclass = "planrub";
				break;
			}
	
 			$citexteplan .= '<li>';
 			
			$titre = interdire_scripts(supprimer_numero(typo(extraire_multi($titre))));
			$url = htmlspecialchars(vider_url(generer_url_rubrique($my_rubrique)));
			$citexteplan .= '<a href="'.$url.'" class="'.$ciclass.'">'.$titre.'</a>';
	 			
			ci_enfantplan($my_rubrique);
 			$citexteplan .= '</li>';
		}

		if ($i > 1)
			$citexteplan .= '</ul>';
	
 	}	
	$i=$i-1;
}


// Renvoi un  tableau associant chaque rubrique parente  un tableau de ses rubriques filles
// sous reserve que l'auteur puisse acceder a ces rubriques dans l'espace prive 
function ci_arbo_plan() {
// le contenu de $ciliste_rubriques varie si l'utilisateur est authentifi ou non
	global $var_preview, $ciliste_rubriques,$ciliste_rubdusite,$ciliste_rubprepa; 
	
	$ciarbo = array();
	$cienfants = array();
	$ciparent = 0;
	$cirubmasque = array();
	$masqueexiste = false;

	// les rubriques masques
   	$querym = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_mot=mots.id_mot AND mots.titre='_masquer_dans_plan'";
	$resultm = @spip_query($querym);
	
	if ($resultm) {
		$masqueexiste = true;
		while ($rowm = @spip_fetch_array($resultm)) {
			$cirubmasque[]=$rowm['id_rubrique'];
		}
	}	
	
	
	if ($var_preview)  {
		$query = "SELECT rubriques.id_parent,rubriques.id_rubrique,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE ((rubriques.statut='publie'  AND rubriques.id_rubrique NOT IN ".$ciliste_rubriques.") OR (rubriques.statut IN ('prive','prepa') AND rubriques.id_rubrique IN ".$ciliste_rubprepa.")) ORDER BY id_parent,num";
	} else {
	    $query = "SELECT rubriques.id_parent,rubriques.id_rubrique,rubriques.titre,0+rubriques.titre AS num FROM spip_rubriques AS rubriques WHERE rubriques.id_rubrique NOT IN ".$ciliste_rubriques." AND rubriques.statut='publie' ORDER BY id_parent,num";
	}
	if (cilire_config('cimultisites')=="oui") $query = str_replace('WHERE','WHERE rubriques.id_rubrique IN '.$ciliste_rubdusite.' AND',$query);
	
	$result2 = spip_query($query);
	while($row = spip_fetch_array($result2)){
		if ($ciparent) {
			if ($ciparent!=$row['id_parent']+1) {
				if (!$masqueexiste OR !in_array($ciparent-1,$cirubmasque)) 
					$ciarbo["p".strval($ciparent-1)] = $cienfants;

				$ciparent = $row['id_parent']+1;
				$cienfants = array();
			}
		} else {
			$ciparent = $row['id_parent']+1;
		}
		
		if (!$masqueexiste OR !in_array($row['id_rubrique'],$cirubmasque)) 
			$cienfants[] = array($row['id_rubrique'],$row['titre']);
		
		// si le parent est masqu, il faut masquer les enfants
		if ($masqueexiste AND in_array($row['id_parent'],$cirubmasque)) 
			$cirubmasque[] = $row['id_rubrique'];
	}
	// Traiter le dernier lot 
	if ($ciparent) {
		if (!$masqueexiste OR !in_array($ciparent-1,$cirubmasque)) 
			$ciarbo["p".strval($ciparent-1)] = $cienfants;

		$ciparent = $row['id_parent']+1;
		$cienfants = array();
	}

	return $ciarbo;
}

//---------- Fin ajout CI ------

//---------- Debut ajout CI (volumetrie rubrique) -------
// Une balise ajoute  SPIP contient l'appel  cette fonction
// cette fonction permet de construire l'arborescence des rurbiques avec des cases  cocher 
function ciequip_rubart($Pile,$SP) {
// le contenu de $ciliste_rubriques varie si l'utilisateur est authentifi ou non
	global $var_preview, $ciliste_rubriques,$ciliste_rubdusite,$ciliste_rubprepa; 

	global $citexterubart;
	global $ciarbo;
	
	$ciarbo = ci_arbo_rubriques();
	$citexterubart = '<ul class="plansite">';
	ci_enfantrubart(0);
	$citexterubart .= '</ul>';
	
	return $citexterubart;  
}	
	

function ci_enfantrubart($leparent){
	global $id_parent;
	global $id_rubrique;
	static $i = 0, $premier = 1;
	global $statut;
	global $connect_toutes_rubriques;
	global $ciarbo;
	global $citexterubart;
	
	$i++;
 	$citableau = $ciarbo["p".strval($leparent)];	
	 	
	 	
 	if ($citableau) {
		if ($i > 1)
	 		$citexterubart .= '<ul>';
		
	 	foreach($citableau as $row) {
			$my_rubrique=$row[0];
			$titre=$row[1];
			$statut_rubrique=$row[2];
			$lang_rub = $row[3];
			$langue_choisie_rub = $row[4];
		
			$ciclass = "";
	
			// si l'article est publie il faut etre admin pour avoir le menu
			// sinon le menu est present en entier (proposer un article)
			if ($statut != "publie" OR acces_rubrique($my_rubrique)) {			
				$rubrique_acceptable = true;
			} else {
				$rubrique_acceptable = false;
			}
	
			switch ($i) {
			case 1:
				$ciclass = "plansecteur";
				break;
			case 2:
				$ciclass = "planrubniv1";
				break;
			default:
				$ciclass = "planrub";
				break;
			}
	
 			$citexterubart .= '<li>';
 			
			if ($rubrique_acceptable) {
				if ($i == 1 && !$premier) $citexterubart .= "<hr>"; // sert a separer les secteurs
				$titre = supprimer_tags(typo(extraire_multi($titre)));
				if ($my_rubrique==$id_rubrique) {
					$citexterubart .= '<div class="'.$ciclass.'"><input type="radio" id="rub'.$my_rubrique.'" name="id_rubart" value="'.$my_rubrique.'" checked="checked" ><label for="rub'.$my_rubrique.'" class="texte gras"> '.$titre.'</label></div>';
				} else {
					$citexterubart .= '<div class="'.$ciclass.'"><input type="radio" id="rub'.$my_rubrique.'" name="id_rubart" value="'.$my_rubrique.'" ><label for="rub'.$my_rubrique.'" class="texte"> '.$titre.'</label></div>';
				}		
			}
	 			
			$premier = 0;
			ci_enfantrubart($my_rubrique);
 			$citexterubart .= '</li>';
		}

		if ($i > 1)
			$citexterubart .= '</ul>';
	
 	}	
	$i=$i-1;
}


// Renvoi un  tableau associant chaque rubrique parente  un tableau de ses rubriques filles
// sous reserve que l'auteur puisse acceder a ces rubriques dans l'espace prive 
function ci_arbo_rubriques() {
	global $lecture_toutes_rubriques;
	global $lecture_id_rubrique;
	global $connect_id_auteur;
	global $ci_tabrubari;
	
	$ciarbo = array();
	$cienfants = array();
	$tabrubstatut6forum = array();
	$existrubstatut6forum = false;
	$ciparent = 0;
	$ci_id_enfant = 0;
	$ciauteursecteurs = array();
	$cisecteurs = array();
		
	// rubriques EC o le statut l'auteur est visiteur par surcharge
	$result = spip_query("SELECT id_rubrique FROM spip_ci_droit_rubriques WHERE statut='6forum' AND id_auteur=".$connect_id_auteur);
	while ($row = spip_fetch_array($result)) {
		if ($ci_tabrubari[$row['id_rubrique']]) {
			$tabrubstatut6forum[] = $row['id_rubrique'];
			$existrubstatut6forum = true;
		}
	}
	
	// Pas de rubriques affectes  l'auteur
	if ($lecture_toutes_rubriques) {
		$query = "SELECT id_parent,id_rubrique,titre,statut,lang,langue_choisie FROM spip_rubriques ORDER BY id_parent, 0+titre, titre";
		$result2 = spip_query($query);
		while($row = spip_fetch_array($result2)){
			if ($ciparent) {
				if ($ciparent!=$row['id_parent']+1) {
					if ($lecture_toutes_rubriques OR in_array(strval($ciparent-1),$lecture_id_rubrique)) {
						if (!$existrubstatut6forum OR !in_array(strval($ciparent-1),$tabrubstatut6forum)) {
							$ciarbo["p".strval($ciparent-1)] = $cienfants;
						}
					}	
					$ciparent = $row['id_parent']+1;
					$cienfants = array();
				}
			} else {
				$ciparent = $row['id_parent']+1;
			}
			if ($lecture_toutes_rubriques OR in_array($row['id_rubrique'],$lecture_id_rubrique)) {
				if (!$existrubstatut6forum OR !in_array($row['id_rubrique'],$tabrubstatut6forum))
					$cienfants[] = array($row['id_rubrique'],$row['titre'],$row['statut'],$row['lang'],$row['langue_choisie']);
			}
		}
		
		// Traiter le dernier lot 
		if ($ciparent) {
			if ($lecture_toutes_rubriques OR in_array(strval($ciparent-1),$lecture_id_rubrique)) {
				if (!$existrubstatut6forum OR !in_array(strval($ciparent-1),$tabrubstatut6forum)) {
					$ciarbo["p".strval($ciparent-1)] = $cienfants;
				}
			}	
		}
		
	// Il existe des rubriques affectes  l'auteur
	} elseif (isset($lecture_id_rubrique)) {

		// les "premires" rubriques parentes dans l'arborescence autorise pour l'auteur
		// doivent jouer le role de secteur 
		$query3 = "SELECT id_rubrique FROM spip_auteurs_rubriques WHERE id_auteur=$connect_id_auteur AND id_rubrique!='0'";
		$result3 = spip_query($query3);
		while($row = spip_fetch_array($result3)){
			$ciauteursecteurs[] = $row['id_rubrique'];
		}		
		
		$query = "SELECT id_parent,id_rubrique,titre,statut,lang,langue_choisie FROM spip_rubriques WHERE id_rubrique IN (".implode(", ",$lecture_id_rubrique).") ORDER BY id_parent, 0+titre, titre";
		$result2 = spip_query($query);
		while($row = spip_fetch_array($result2)) {
			if ($ciparent) {
				if ($ciparent!=$row['id_parent']+1) {
						if (!$existrubstatut6forum OR !in_array(strval($ciparent-1),$tabrubstatut6forum)) {
							// Eviter le cas ou une rubrique et sa fille sont affectees a un auteur
							if (isset($ciauteursecteurs) AND in_array($ci_id_enfant,$ciauteursecteurs) AND !in_array($ciparent-1,$lecture_id_rubrique)) {
								$cisecteurs[] = $cienfants;
							} else {
								$ciarbo["p".strval($ciparent-1)] = $cienfants;
							}
						}
					$ciparent = $row['id_parent']+1;
					$cienfants = array();
				}
			} else {
				$ciparent = $row['id_parent']+1;
			}
				if (!$existrubstatut6forum OR !in_array($row['id_rubrique'],$tabrubstatut6forum)) {
					$cienfants[] = array($row['id_rubrique'],$row['titre'],$row['statut'],$row['lang'],$row['langue_choisie']);
					$ci_id_enfant = $row['id_rubrique'];
				}
		}
		// Traiter le dernier lot 
		if ($ciparent) {
			if (!$existrubstatut6forum OR !in_array(strval($ciparent-1),$tabrubstatut6forum)) {
				// Eviter le cas ou une rubrique et sa fille sont affectees a un auteur
				if (isset($ciauteursecteurs) AND in_array($ci_id_enfant,$ciauteursecteurs) AND !in_array($ciparent-1,$lecture_id_rubrique)) {
					$cisecteurs[] = $cienfants;
				} else {
					$ciarbo["p".strval($ciparent-1)] = $cienfants;
				}
			}
		}

		// les "premires" rubriques parentes dans l'arborescence autorise pour l'auteur
		// doivent jouer le role de secteur 
		if (isset($cisecteurs)) {
		 	foreach($cisecteurs as $cisecteur) {
			 	foreach($cisecteur as $cisect) {
					$cisecteurarbo[] = $cisect;
			 	}
		 	}
			$ciarbo["p0"] = $cisecteurarbo;
		}
	}

	return $ciarbo;
}

//---------- Fin ajout CI ------


?>