<?php

// Ce fichier ne sera execute qu'une fois
if (defined("_GISEH_INC_AUTH")) return;
define("_GISEH_INC_AUTH", "1");


//--------- Debut ajout CI (ec)(ar)---------------------
function ci_lecture_rubrique($id_rubrique) {
	global $lecture_toutes_rubriques;
	global $lecture_id_rubrique;
	global $ci_tabrubari;
//----------------- Debut ajout CI (varianteec) -----
//	global $connect_statut;
	$connect_statut=ci_connect_statut($id_rubrique);
	if ($connect_statut=='6forum') {
		$return=false;
	} else {
//----------------- Fin ajout CI --------------------
		$return= ($lecture_toutes_rubriques OR $lecture_id_rubrique[$id_rubrique]);
	
		if ($lecture_toutes_rubriques){
			if ($ci_tabrubari AND $id_rubrique!=0){
				if ($ci_tabrubari[$id_rubrique]){
					if($lecture_id_rubrique[$id_rubrique]){ 
						// admin du site affectable et affect
						// ou rdacteur affectable et affect
						$return=true;
					} else {
						$return=false;
					}
				}
			}
		}
	}	
	// on laisse passer l'administrateur tout court
//	if ($connect_toutes_rubriques AND $connect_statut == "0minirezo"){
//		$return=true;
//	}
	
	return $return;	
}

function ci_lecture_rubrique_stat($id_rubrique) {
	global $lecture_toutes_rubriques;
	global $lecture_id_rubrique;
	global $ci_tabrubari;
	global $connect_statut;
//	Pour la colonne de gauche des stat, ne pas vrifier le statut	
//	$connect_statut=ci_connect_statut($id_rubrique);
	if ($connect_statut=='6forum') {
		$return=false;
	} else {
		$return= ($lecture_toutes_rubriques OR $lecture_id_rubrique[$id_rubrique]);
	
		if ($lecture_toutes_rubriques){
			if ($ci_tabrubari AND $id_rubrique!=0){
				if ($ci_tabrubari[$id_rubrique]){
					if($lecture_id_rubrique[$id_rubrique]){ 
						// admin du site affectable et affect
						// ou rdacteur affectable et affect
						$return=true;
					} else {
						$return=false;
					}
				}
			}
		}
	}	
	
	return $return;	
}


function ci_lecture_article($id_article) {
	$return=true;
	
	if ($id_article) {
		$query = "SELECT id_rubrique FROM spip_articles WHERE id_article=".$id_article;
		$result = @spip_query($query);
		if ($row = spip_fetch_array($result)) {
			$ciidrub= $row['id_rubrique'];
		}
		if ($ciidrub) {
			$return=ci_lecture_rubrique($ciidrub);
		}
	}
		
	return $return;	
}

function ci_lecture_syndic($id_syndic) {
	$return=true;
	
	if ($id_syndic) {
		$query = "SELECT id_rubrique FROM spip_syndic WHERE id_syndic=".$id_syndic;
		$result = @spip_query($query);
		if ($row = spip_fetch_array($result)) {
			$ciidrub= $row['id_rubrique'];
		}
		if ($ciidrub) {
			$return=ci_lecture_rubrique($ciidrub);
		}
	}
		
	return $return;	
}

function ci_tabrubari($id_rubrique) {
	global $ci_tabrubari;

	return ($ci_tabrubari[$id_rubrique]);
}

function ci_connect_ciredval($id_rubrique=0) {
	global $connect_id_auteur;

	static $tabciredval;
	
	$return=false;
	
	if ($connect_id_auteur){
		$query = "SELECT * FROM spip_auteurs WHERE id_auteur=$connect_id_auteur";
		$result = spip_query($query);
	
		while ($row = spip_fetch_array($result)) {
			$ciredval = $row['statut'];		
			if ($ciredval=="ciredval") $return=true;
		}
	
		if ($id_rubrique>0) {
			if (isset($tabciredval[$id_rubrique])) {
					if ($tabciredval[$id_rubrique]=='ciredval') {
						$return=true;
					} else {
						$return=false;
					}						
			} else {
				if (ci_ari($id_rubrique)) {	
					$result = spip_query("SELECT statut FROM spip_ci_droit_rubriques WHERE id_rubrique=".$id_rubrique." AND id_auteur=".$connect_id_auteur);
					while ($row = spip_fetch_array($result))
						$cistatut = $row['statut'];
		
					if ($cistatut) {	
						if (ereg("^(eccma|0minirezo|1comite|ciredval|5poubelle|6forum)$",$cistatut)) {	
							$tabciredval[$id_rubrique]=$cistatut;
							if ($cistatut=='ciredval') {
								$return=true;
							} else {
								$return=false;
							}		
						}	
					}
 				} elseif (ci_ari_heritage($id_rubrique)) {
					// on cherche dans les parents (hritage)	
					$cilisteparents=ci_ascendanceari($id_rubrique);
					$result = spip_query("SELECT statut FROM spip_ci_droit_rubriques WHERE id_rubrique IN ".$cilisteparents." AND id_auteur=".$connect_id_auteur." ORDER BY id_rubrique DESC");
					while ($row = spip_fetch_array($result))
						$cistatut = $row['statut'];
						
					if ($cistatut) {	
						if (ereg("^(eccma|0minirezo|1comite|ciredval|5poubelle|6forum)$",$cistatut)) {		
							$tabciredval[$id_rubrique]=$cistatut;
							if ($cistatut=='ciredval') {
								$return=true;
							} else {
								$return=false;
							}		
						}
					}		
				}
			}			
		}	
	}
	
	return $return;	
}

function ci_connect_eccma($id_rubrique=0) {
	global $connect_statut, $connect_id_auteur;
	
	static $tabeccma;
	
	$return=false;
	
	if ($connect_id_auteur) {
		if ((ci_droitauteur('eccma') OR ci_droitauteur('ecadminsite')) AND ($connect_statut == '0minirezo')) $return=true;

		if ($id_rubrique>0) {
			if (isset($tabeccma[$id_rubrique])) {
					if ($tabeccma[$id_rubrique]=='eccma') {
						$return=true;
					} else {
						$return=false;
					}						
			} else {
				if (ci_ari($id_rubrique)) {	
					$query = "SELECT statut FROM spip_ci_droit_rubriques WHERE id_rubrique=".$id_rubrique." AND id_auteur=".$connect_id_auteur;
					$result = spip_query($query);
					while ($row = spip_fetch_array($result))
						$cistatut = $row['statut'];
					
					if ($cistatut) {
						if (ereg("^(eccma|0minirezo|1comite|ciredval|5poubelle|6forum)$",$cistatut)) {
							$tabeccma[$id_rubrique]=$cistatut;
							if ($cistatut=='eccma') {
								$return=true;
							} else {
								$return=false;
							}		
						}	
					}
				} elseif (ci_ari_heritage($id_rubrique)) {
					// on cherche dans les parents (hritage)	
					$cilisteparents=ci_ascendanceari($id_rubrique);
					$result = spip_query("SELECT statut FROM spip_ci_droit_rubriques WHERE id_rubrique IN ".$cilisteparents." AND id_auteur=".$connect_id_auteur." ORDER BY id_rubrique DESC");
					while ($row = spip_fetch_array($result))
						$cistatut = $row['statut'];
						
					if ($cistatut) {	
						if (ereg("^(eccma|0minirezo|1comite|ciredval|5poubelle|6forum)$",$cistatut)) {
							$tabeccma[$id_rubrique]=$cistatut;								
							if ($cistatut=='eccma') {
								$return=true;
							} else {
								$return=false;
							}		
						}
					}		
				}
			}
		}		
	}
		
	return $return;
	
}	


function ci_connect_statut($id_rubrique=0) {
	global $connect_statut, $connect_id_auteur;
	
	$return=$connect_statut;
	if ($connect_id_auteur AND $id_rubrique>0) {
		if (ci_ari($id_rubrique)) {	
			$result = spip_query("SELECT statut FROM spip_ci_droit_rubriques WHERE id_rubrique=".$id_rubrique." AND id_auteur=".$connect_id_auteur);
			while ($row = spip_fetch_array($result))
				$cistatut = $row['statut'];

			if ($cistatut) {
				if (ereg("^(eccma|0minirezo|1comite|ciredval|5poubelle|6forum)$",$cistatut)) $return=$cistatut;
				if ($return == 'ciredval') $return='1comite';	
				if ($return == 'eccma') $return='0minirezo';	
			}
		} elseif (ci_ari_heritage($id_rubrique)) {
			// on cherche dans les parents (hritage)	
			$cilisteparents=ci_ascendanceari($id_rubrique);
			$result = spip_query("SELECT statut FROM spip_ci_droit_rubriques WHERE id_rubrique IN ".$cilisteparents." AND id_auteur=".$connect_id_auteur." ORDER BY id_rubrique DESC");
			while ($row = spip_fetch_array($result))
				$cistatut = $row['statut'];
			if ($cistatut) {	
				if (ereg("^(eccma|0minirezo|1comite|ciredval|5poubelle|6forum)$",$cistatut)) $return=$cistatut;
				if ($return == 'ciredval') $return='1comite';	
				if ($return == 'eccma') $return='0minirezo';	
			}		
		}	
	}	
	
	return $return;
}	


function ci_connect_statut_etendu($id_rubrique=0) {
	global $connect_statut, $connect_id_auteur;
	
	$return=ci_connect_statut($id_rubrique);
	if ($return == '1comite') {
		if (ci_connect_ciredval($id_rubrique)) $return='ciredval';
	}		
	if ($return == '0minirezo') {
		if (ci_connect_eccma($id_rubrique)) $return='eccma';	
	}
	
	return $return;
}	

//--------- Fin ajout CI ---------------------

?>
