<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2008                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;


function giseh_action_editer_article_datepublication($array_droits,$connect_id_auteur,$connect_statut,$cilogin) {

	$return = true;
	
	$ci_id_article = _cireqsecure('id_article');
	
	if ($ci_id_article>0) {
	
		// date de publication
		$datepublication = _cireqsecure('datepublication');
		$heurepublication = _cireqsecure('heurepublication');
		
	
		if ($datepublication AND $heurepublication) {
			$jour = substr($datepublication,0,2);
			$mois = substr($datepublication,3,2);
			$annee = substr($datepublication,6,4);
			$heure = substr($heurepublication,0,2);
			$minute = substr($heurepublication,3,2);
		
			$date = sprintf("%04s",$annee) . '-' 
				. sprintf("%02s",$mois) . '-'
				. sprintf("%02s",$jour) . ' ' 
				. sprintf("%02s",$heure) . ':'
				. sprintf("%02s",$minute) . ':' 
				. sprintf("%02s",0);
			
			cisql_updateq("spip_articles", array("date" => $date), "id_article=$ci_id_article");
			
		} else {
			$return = false;
			$message = "";
			if (!$datepublication) $message = "Date incorrecte";
			if (!$heurepublication) {
				if ($message)
					$message .= "et heure incorrecte";
				else
					$message = "Heure incorrecte";
			}
			$_POST['form_erreur'] = $message;
		}
		
	}

	return $return;
}
?>