<?php
//---------- Debut ajout CI -----

// Ce fichier ne sera execute qu'une fois
 if (defined("_CI_CONFIG")) return;
 define("_CI_CONFIG", "1"); 

$ciflag_ecrire = !file_exists('./ecrire/inc_version.php3');
 
 //--------- Debut ajout CI (convergence) -----
// Ce fichier est communs aux sites et contient le choix de paramtrage ou non par fichier, etc.
// A mettre imprativement au dbut
$ci_param_fichier="_config_commun.php3";
if (!$ciflag_ecrire) $ci_param_fichier="ecrire/".$ci_param_fichier;
// Attention : ne pas mettre include_once
if (file_exists($ci_param_fichier))  include($ci_param_fichier);
//--------- Fin ajout CI -----

 
// paramtrage par dfaut si le fichier de paramtrage correspondant n'existe pas	
$GLOBALS['ciconfig']['ciadressesite'] = '';
$GLOBALS['ciconfig']['citypesite'] = 'intra';	
$GLOBALS['ciconfig']['cimultisites'] = 'non';
$GLOBALS['ciconfig']['cixiti'] = '_images/void.gif?';
$GLOBALS['ciconfig']['cicss'] = '';
$GLOBALS['ciconfig']['cigaucherubrique'] = '';
$GLOBALS['ciconfig']['cigauchearticle'] = '';
$GLOBALS['ciconfig']['ciarinter'] = 'non';
$GLOBALS['ciconfig']['cisansarintra'] = 'non';
if (defined("_CI_SANS_UPLOAD_CSS")) {
	$GLOBALS['ciconfig']['cicssperso'] = 'non';
} else {
	$GLOBALS['ciconfig']['cicssperso'] = 'oui';
}
//--------- Debut ajout CI (version CAS) -----
$GLOBALS['ciconfig']['cicas'] = '';
$GLOBALS['ciconfig']['cicasuid'] = '';
$GLOBALS['ciconfig']['cicasurldefaut'] = '';
$GLOBALS['ciconfig']['cicasrepertoire'] = '';
$GLOBALS['ciconfig']['cicasurls'] = '';
//--------- Fin ajout CI -----
//--------- Debut ajout CI (host auth site public) -----
$GLOBALS['ciconfig']['cicassp'] = '';
$GLOBALS['ciconfig']['cicasspurls'] = '';
$GLOBALS['ciconfig']['cicasipsp'] = '';
$GLOBALS['ciconfig']['cicasipspnetv4'] = '';
$GLOBALS['ciconfig']['cicasipspordre'] = '';
//--------- Fin ajout CI -----


//--------- Debut ajout CI (version CAS) -----
// Ajout de "_config_cas.php3"
//--------- Fin ajout CI -----

$citab_param_fichier=array(
"_config_typesite.php3",
"_config_adresse.php3",
"_config_multisites.php3",
"_config_arinter.php3",
"_config_cas.php3",
"_config_xiti.php3",
"_config_cssperso.php3",
"_config_css.php3",
"_config_delai.php3",
"_config_bandeau.php3");

$citab_param_fichier2=array(
"_config_typesite.php3",
"_config_adresse.php3",
"_config_multisites.php3",
"_config_arinter.php3",
"_config_cas.php3");

if (defined('_CI_PARAM_FICHIER')) {
	foreach ($citab_param_fichier as $ci_param_fichier) {
		if (!$ciflag_ecrire) $ci_param_fichier="ecrire/".$ci_param_fichier;
		// Attention : ne pas mettre include_once
		if (file_exists($ci_param_fichier))  include($ci_param_fichier);
	}
} else {
	foreach ($citab_param_fichier2 as $ci_param_fichier) {
		if (!$ciflag_ecrire) $ci_param_fichier="ecrire/".$ci_param_fichier;
		// Attention : ne pas mettre include_once
		if (file_exists($ci_param_fichier))  include($ci_param_fichier);
	}
}


if ($GLOBALS['ciconfig']['cimultisites'] == 'non'){
	$GLOBALS['ciconfig']['cisite'] = '';
	$GLOBALS['ciconfig']['ciadressesitepiecesjointes'] = '';
	$GLOBALS['ciconfig']['ciIMG'] = '';
	$GLOBALS['ciconfig']['cilistedessites'] = '';
	$GLOBALS['ciconfig']['cinomdessites'] = '';
	$GLOBALS['ciconfig']['cimonoversmultisites'] = '';
	$GLOBALS['ciconfig']['cisiteexistant'] = '';

}

// Si internet, par dfaut ciautorisear est  non
// Si intranet, par dfaut ciautorisear est  oui
$GLOBALS['ciconfig']['ciautorisear'] = 'non';

if ($GLOBALS['ciconfig']['citypesite'] == 'intra' AND $GLOBALS['ciconfig']['cisansarintra'] != 'oui'){
	$GLOBALS['ciconfig']['ciautorisear'] = 'oui';
}

if ($GLOBALS['ciconfig']['citypesite'] == 'inter' AND $GLOBALS['ciconfig']['ciarinter'] == 'oui'){
	$GLOBALS['ciconfig']['ciautorisear'] = 'oui';
}

// feuille de style par dfaut
if ($GLOBALS['ciconfig']['citypesite'] == 'inter'){
	define("_CI_DEFAULT_CSS", _CI_DEFAULT_CSS_INTER);  	
} else {
	define("_CI_DEFAULT_CSS", _CI_DEFAULT_CSS_INTRA);
}

function cilire_config($nom) {
	global $ciconfig;
	
	return $ciconfig[$nom];
}

if (file_exists(($ciflag_ecrire ? "" : "ecrire/")."data/meta_cache.php3"))
	include_once(($ciflag_ecrire ? "" : "ecrire/")."data/meta_cache.php3");


function ci_url_cssperso() {
	global $ciconfig;
		
	// css choisie priorit 3
	$ciresult = lire_meta('equip_css');

	// css impose priorit 2
	if (cilire_config("cicss")!="") {
		$ciresult = cilire_config("cicss");
	}
	
	// css perso priorit 1
	if (cilire_config("cicssperso")=="oui") {
		if (cilire_config("cimultisites")=="oui") {
			$cicheminfichier = cilire_config("ciIMG")."/".cilire_config('cisite')."/perso_style_site.css";
			if (file_exists($cicheminfichier)) { 
				if (cilire_config("ciadressesitepiecesjointes")=="") {
					$ciresult = "IMG/".cilire_config('cisite')."/perso_style_site.css";
				} else {
					$ciresult = cilire_config("ciadressesitepiecesjointes")."/IMG/".cilire_config('cisite')."/perso_style_site.css";
				}			
			}	
		} else {	
			if (file_exists('IMG/perso_style_site.css')) $ciresult = 'IMG/perso_style_site.css';
		}
	}
	return $ciresult;
}

//---------- Fin ajout CI -----

?>