<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2005                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/





// Distinguer une inclusion d'un appel initial
if (defined("_INC_PUBLIC")) {
//--------- Debut ajout CI (convergence) ------
	if ($cicharte) {
		$cifond = str_replace("_template/","_template/".$cicharte,$fond);
		if (@is_readable($cifond.".html")) {
			$fond = $cifond;
		}
	}	
//--------- Fin ajout CI -----
	$page = inclure_page($fond, $delais, $contexte_inclus);
	if ($page['process_ins'] == 'html')
		echo $page['texte'];
	else
		eval('?' . '>' . $page['texte']);

	if ($page['lang_select'] === true)
		lang_dselect();

} else {
	define ("_INC_PUBLIC", 1);
	if (!function_exists('include_local')) { # cas de page.php3
		include_once("ecrire/inc_version.php3");
	}

//--------- Debut ajout CI (convergence) ------
// charte avec des gabarits spcifiques
// la charte est dduite par extraction de la 3 partie du nom de la CSS selectionne

	$cicharte= "";

	include_once('ecrire/mes_options.php3');
	
	// css choisie priorit 3
	if (file_exists('ecrire/data/meta_cache.php3')) {
		include_once("ecrire/data/meta_cache.php3");
		if (isset($GLOBALS['meta']['equip_css'])) {
			$cicharte = $GLOBALS['meta']['equip_css'];
		}
	}

	// css impose priorit 2
	if (cilire_config("cicss")!="") {
		$cicharte = cilire_config("cicss");
	}
	
	// css perso priorit 1
	// Non pris en compte car cela ne permet pas de dduire la charte (les priorits 3 et 2 s'appliquent)
	
	
	if ($cicharte) {
		$cipos = strpos($cicharte, "style_site_") + 11;
		$ciextrait = substr($cicharte,$cipos);
		$cipos2 = strpos($ciextrait,"_");
		if (!$cipos2) $cipos2 = strpos($ciextrait,".");
	    $cicharte= substr($ciextrait,0,$cipos2);
	
	} else {
		// cas ou aucune CSS n'est slectionne
		if(cilire_config('citypesite')){
			if (cilire_config('citypesite')=='inter') { 
				$cicharte='internet';
			} else {
				$cicharte='intranet';
			}
		}
		if (cilire_config('citypesite')=="inter" AND cilire_config('cibandeau')=="anonyme" ) {
		    $cicharte = "interano";
		}
	}
	
	if ($cicharte) {
		$cifond = str_replace("_template/","_template/".$cicharte,$fond);
		if (@is_readable($cifond.".html")) {
			$fond = $cifond;
		}
	}		
//--------- Fin ajout CI -----
	
//--------- Debut ajout CI (purge complte par exemple en cas de changement de version de giseh) -----
	if (file_exists('CACHE/.purgeci')) {
		include_ecrire('inc_connect.php3');
		if ($db_ok) {
			unlink('CACHE/.purgeci');
			spip_log("purge totale ci");
			include_local ("inc-cache.php3");
			purger_repertoire('CACHE', 0);
		}
		
		//--------- Debut ajout CI (migration version BDD) -----
		if (file_exists('CACHE/.migrerci')) {
			include_ecrire("inc_meta.php3");
			$version_installee = (double) str_replace(',','.',lire_meta('version_installee'));
			if ($version_installee < $spip_version) {
				include_ecrire ("inc_base.php3");
				include("mes_fonctions.php3");  // indispensable
				
				creer_base();
				$ciokmaj = maj_base();
				if ($ciokmaj) {
					include_ecrire("inc_config.php3");
					init_config();
				}	
			}
			spip_log('unlink CACHE/.migrerci');
			unlink('CACHE/.migrerci');
		}	
		//--------- Fin ajout CI -----
		
	}
//--------- Fin ajout CI ---------------------
	
	include_local('inc-public-global.php3');

	// Calculer la page sans evaluer le php qu'elle contient
	$page = calcule_header_et_page ($fond, $delais);

	// Execution de la page calculee

	// 1. Cas d'une page contenant uniquement du HTML :
	if ($page['process_ins'] == 'html') {
		$page = $page['texte'];
	}

	// 2. Cas d'une page contenant du PHP :
	// Attention cette partie eval() doit imperativement
	// etre declenchee dans l'espace des globales (donc pas
	// dans une fonction).
	else {
		// Une page "normale" va s'afficher ici
		if (! ($flag_ob 
			AND (($var_mode == 'debug')
				OR $var_recherche
				OR $affiche_boutons_admin
				OR $xhtml		))) {
			eval('?' . '>' . $page['texte']);
			$page = '';
		}

		// Certains cas demandent un ob_start() de plus
		else {
			ob_start(); 
			$res = eval('?' . '>' . $page['texte']);
			$page = ob_get_contents(); 
			ob_end_clean();

			// en cas d'erreur lors du eval,
			// la memoriser dans le tableau des erreurs
			// On ne revient pas ici si le nb d'erreurs > 4
			if ($res === false AND $affiche_boutons_admin
			AND $auteur_session['statut'] == '0minirezo') {
				include_ecrire('inc_debug_sql.php3');
				erreur_squelette(_T('zbug_erreur_execution_page'));
			}
		}
	}

	// Passer la main au debuggueur le cas echeant 
	if ($var_mode == 'debug') {
		include_ecrire("inc_debug_sql.php3");
		debug_dumpfile($var_mode_affiche== 'validation' ? $page :"",
			       $var_mode_objet,$var_mode_affiche);
	} 
	if (count($tableau_des_erreurs) > 0 AND $affiche_boutons_admin)
		$page = affiche_erreurs_page($tableau_des_erreurs) . $page;

	// Traiter var_recherche pour surligner les mots
	if ($var_recherche) {
		include_ecrire("inc_surligne.php3");
		$page = surligner_mots($page, $var_recherche);
	}

	// Valider/indenter a la demande. garder la compatibilite tidy
	if (trim($page) AND $xhtml AND !$flag_preserver AND !headers_sent()) {
		if ($xhtml === true) $xhtml = 'tidy';
		$file = 'inc_' . $xhtml. ".php";
#		spip_log(_DIR_RESTREINT . $file);
		if (is_readable(_DIR_RESTREINT . $file)) { include_ecrire($file); }
		if (function_exists($xhtml))
			$page = $xhtml($page);
		else if (function_exists('xhtml'))
			$page = xhtml($page);
	}

	// Inserer au besoin les boutons admins
	if ($affiche_boutons_admin) {
		include_local("inc-admin.php3");
		$page = affiche_boutons_admin($page);
	}

	// Affichage final s'il en reste
	echo $page;

	// Taches de fond ?
//--------- Debut ajout CI ( ne pas prendre en compte dans statistiques le robot et la syndication) ------
//	terminer_public_global();
	terminer_public_global($fond);
//--------- Fin ajout CI ---------------------
}

?>