<?php

include_once("ecrire/inc_version.php3");
include_ecrire("inc_session.php3");
include_ecrire('inc_connect.php3');
include_ecrire("inc_texte.php3");
include_ecrire("inc_filtres.php3");
include_ecrire('_giseh_inc_ari.php3');
include_ecrire('_giseh_inc_auth.php3');
include("inc-calcul.php3");


// securite
$ciflag_lecture=false;
$id_article = intval($_GET['id_article']);
$id_document = intval($_GET['id_document']);
$ciflag_reserverpj=false;
$ciflag_redirection=false;
$ciflag_resapj_existe=false;

/* Dans le champs PS de l'article sont stockes les rservations
   sous la forme <$id_document>$id_auteur</$id_document>
*/
function ci_lire_resapj($id_article,$id_document){

	$cle = strval($id_document);
	$texte="";
	$id_auteur=0;
	
	$query = "SELECT * FROM spip_articles WHERE id_article=$id_article";
	$result = spip_query($query);
	if ($row = spip_fetch_array($result)) {
		$texte=$row['ps'];
	}
	
	if($texte AND $cle){	
		$tagdebut="<".$cle.">";
		$posdebut = strpos($texte, $tagdebut);
		if ($posdebut === false){
			$id_auteur=0;
		} else {	 		
			$tagfin="</".$cle.">";
			$posdebut = $posdebut + strlen($cle) +2;
			$longval = strpos($texte, $tagfin)-$posdebut;
			$id_auteur=intval(substr($texte,$posdebut,$longval));
		}
	}	
	return $id_auteur;
}

function ci_maj_resapj($id_article,$id_document,$id_auteur){

	$cle = strval($id_document);
	$texte="";
	$newtexte="";
	
	$query = "SELECT * FROM spip_articles WHERE id_article=$id_article";
	$result = spip_query($query);
	if ($row = spip_fetch_array($result)) {
		$texte=$row['ps'];
	}
	
	if (!$texte) $texte='';
	if($cle){	
		$tagdebut="<".$cle.">";
		$tagfin="</".$cle.">";
		$posdebut = strpos($texte, $tagdebut);
		if ($posdebut === false){
			$oldval='';
		} else {	 		
			$tagfin="</".$cle.">";
			$posdebut = $posdebut + strlen($cle) +2;
			$longval = strpos($texte, $tagfin)-$posdebut;
			$oldval=substr($texte,$posdebut,$longval);
		}
		
		if ($oldval){
			$oldval=$tagdebut.$oldval.$tagfin;
			$newval=$tagdebut.$id_auteur.$tagfin;
			$newtexte=str_replace($oldval,$newval,$texte);
		} else {
			$posdebut = strpos($texte, $tagdebut);
			if ($posdebut === false){
				$newtexte=$texte.$tagdebut.$id_auteur.$tagfin;
			} else {		
				// pas de valeur mais les tags existent
				$oldval=$tagdebut.$tagfin;
				$newval=$tagdebut.$id_auteur.$tagfin;
				$newtexte=str_replace($oldval,$newval,$texte);			
			}	
		}
		
		$query = "UPDATE spip_articles SET ps='$newtexte' WHERE id_article=$id_article";
		$result = spip_query($query);
		
	}
	
	return true;
}

// vrifier si le document est dj rserv
$id_auteur=ci_lire_resapj($id_article,$id_document);
if ($id_auteur>0) {
	$ciflag_resapj_existe=true;
	$_GET['id_auteur']=$id_auteur;
	$_POST['id_auteur']=$id_auteur;	
} else {
	$_GET['id_auteur']=0;
	$_POST['id_auteur']=0;	
}

// vrifier si l'utilisateur demande une rservation
if (isset($_GET['action'])) {
	if ($_GET['action']=='reserverpj') 
		$ciflag_reserverpj=true;
}

// vrifier si redirection depuis le formulaire d'authentification
if (isset($_GET['redirection'])) {
	if ($_GET['redirection']=='oui') 
		$ciflag_redirection=true;
}

if (!$ciflag_reserverpj) {

	$fond = "_template/__article_reserver_pj";
	$delais = 0;
	include ("inc-public.php3");
	
} else {

	// Rserver le document
	
	// Authentification ncessaire	
	if ($HTTP_COOKIE_VARS['spip_session']) {
		// ncessaire pour inc-calcul
		if (verifier_visiteur()){
			$cilogin = $GLOBALS['auteur_session']['login'];
			$connect_statut=$GLOBALS['auteur_session']['statut'];
			$connect_id_auteur=$GLOBALS['auteur_session']['id_auteur'];		
		}
	} else {
		$ciurl = urlencode($clean_link->getUrl().'&redirection=oui');
		@header("Location: ./spip_login.php3?url=$ciurl");
		exit;
	}
	
	
	
	if ($id_article) {
		// l'article est-il un wiki
	   	$querym = "SELECT mots.* FROM spip_mots AS mots,spip_mots_articles AS rel_mots WHERE mots.titre<>'kawax' AND mots.id_mot=rel_mots.id_mot AND rel_mots.id_article=".$id_article." AND mots.titre='_wiki'";
		$resultm = spip_query($querym);
		
		if ($resultm AND spip_num_rows($resultm)>0) {
			
			// l'auteur a-t-il le droit d'accs  l'article sur le site public (protection contre les hack d'url)
			$cilisterubriques = ciaccessrubec();
			
			$query = "SELECT id_article, titre, texte,auteur_modif  FROM spip_articles WHERE id_article=$id_article AND id_rubrique NOT IN ".$cilisterubriques;
			$result = spip_query($query);
		
			if ($row = spip_fetch_array($result)) {
				$titre=$row['titre'];
				$ciflag_lecture = true;
			}		
			
			// si larticle WIKI est dans un EC, il sera modifiable sur le site public selon les mmes droits daccs que dans lespace priv (interdit aux visiteurs)
		   	$querya = "SELECT id_rubrique FROM spip_articles WHERE id_article=".$id_article;
			$resulta = spip_query($querya);
			while ($row = spip_fetch_array($resulta)) $ciidrub = $row["id_rubrique"];
			
			if (ci_ari($ciidrub) OR ci_ari_heritage($ciidrub)) {
				if (ci_connect_statut($ciidrub)=='6forum') $ciflag_lecture = false;
			}	
			
		}	
	}

	if ($ciflag_lecture) {		
		if ($id_article AND $id_document) {
			ci_maj_resapj($id_article,$id_document,$connect_id_auteur);
			ci_maj_resapj($id_article,"time_".$id_document,time());
		}
		
 		if ($ciflag_redirection) {
			$fond = "_template/__article_reserver_pj";
			$delais = 0;
			include ("inc-public.php3");
 		} else {
 			@header("Location: ".generer_url_document($id_document));
 		}
	} else {
		$fond = "_template/__acces_interdit";
		$delais = 0;
		include ("inc-public.php3");
	}	
}

?>
