<?php
/* ----------------------------------------------
Paramtres de configuration pour CAS :
Exemple :
// pour une authentification avec cas, sinon authentification SPIP
$GLOBALS['ciconfig']['cicas'] = 'oui';
// si l'identifiant est stock dans le champ login de la table auteur, mettre 'login' (sinon la recherche sera effectue dans le champs email)
$GLOBALS['ciconfig']['cicasuid'] = '';
// URL du serveur CAS (adresse utilise par dfaut)
$GLOBALS['ciconfig']['cicasurldefaut'] = 'urlcas.i2';
// repertoire du serveur CAS (le cas chant)
$GLOBALS['ciconfig']['cicasrepertoire'] = '/cas';
// tableau des autres URLS du serveurs CAS selon le type de terminaison de l'adresse d'appel du site SPIP
// l'ordre donn dans cet exemple est important, car c'est l'ordre d'examen des terminaisons 
$GLOBALS['ciconfig']['cicasurls'] = array('.ader.gouv.fr' => 'urlcas.ader.gouv.fr', '.gouv.fr' => 'urlcas.ministere.gouv.fr',);
----------------------------------------------- */
$GLOBALS['ciconfig']['cicas'] = '';
$GLOBALS['ciconfig']['cicasuid'] = '';
$GLOBALS['ciconfig']['cicasurldefaut'] = 'authentification-cerbere.application.i2';
$GLOBALS['ciconfig']['cicasrepertoire'] = '/cas';
$GLOBALS['ciconfig']['cicasurls'] = array('.ader.gouv.fr' => 'authentification-cerbere.application.equipement.ader.gouv.fr', '.gouv.fr' => 'authentification-cerbere.application.equipement.gouv.fr');

if (isset($_GET['sso'])) {
	 if ($_GET['sso']=="oui")
		$GLOBALS['ciconfig']['cicas'] = 'oui';
}


/* ----------------------------------------------
Restreindre la consultation du site public aux personnes authentifies
pour tous les HOST ou bien uniquement pour certains HOST ou bien pour tous les HOST sauf certains 

Exemple :
// pour tous les HOST mettre 'tous',
// uniquement pour certains HOST mettre 'uniquement',
// pour tous les HOST sauf certains mettre 'sauf'
$GLOBALS['ciconfig']['cicassp'] = 'tous';

// tableau des HOST pour les cas 'uniquement' ou 'sauf'
// si l'item commence par un point, cela prend en compte les HOST qui se terminent par cet lment
// (en incluant le point)
$GLOBALS['ciconfig']['cicasspurls'] = array('.ader.gouv.fr', '.gouv.fr');
----------------------------------------------- */


/* ----------------------------------------------
Restreindre la consultation du site public aux personnes authentifies
pour toutes les adresses IP ou bien uniquement pour certaines plages d'adresses IP ou bien pour tous les adresses IP sauf certaines plages d'adresses IP 

Exemple :
// pour toutes les adresses IP mettre 'tous',
// uniquement pour certaines plages d'adresses IP mettre 'uniquement',
// pour tous les adresses IP sauf certaines plages d'adresses IP mettre 'sauf'
$GLOBALS['ciconfig']['cicasipsp'] = 'uniquement';

// tableau des plages d'adresses IP pour les cas 'uniquement' ou 'sauf'
$GLOBALS['ciconfig']['cicasipspnetv4'] = array("172.16.0.0"=>"12", "10.0.0.0"=>"8");

// ordre de la recherche de l'adresse IP (la premiere recherche fructueuse l'emporte)
$GLOBALS['ciconfig']['cicasipspordre'] = array('HTTP_X_FORWARDED_FOR','REMOTE_ADDR'); 
----------------------------------------------- */

?>