<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2005                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/


include ("inc.php3");
include_ecrire ("inc_rubriques.php3");
include_ecrire ("inc_logos.php3");
include_ecrire ("inc_mots.php3");
include_ecrire ("inc_documents.php3");
include_ecrire ("inc_abstract_sql.php3");
//--------- Debut ajout CI (ec) -----
include_ecrire ("_giseh_inc_ari.php3");
//--------- Fin ajout CI ------------

//
// Gerer les modifications...
//

$id_parent = intval($id_parent);
$id_rubrique = intval($id_rubrique);
$flag_mots = lire_meta("articles_mots");
//----------------- Debut ajout CI (varianteec) -----
$ci_statut_initial=$connect_statut;
if ($id_rubrique) {
	$connect_statut=ci_connect_statut($id_rubrique);
} elseif ($id_parent) {
	$connect_statut=ci_connect_statut($id_parent);
}
//----------------- Fin ajout CI --------------------

$flag_editable = ($connect_statut == '0minirezo' AND (acces_rubrique($id_parent) OR acces_rubrique($id_rubrique))); // id_parent necessaire en cas de creation de sous-rubrique

//--------- Debut ajout CI (cloisonnement_ep) -----
if ($id_rubrique) {
	if (!ci_lecture_rubrique($id_rubrique)) {
			@header("Location: ./index.php3");
			exit;
	}
}
//----------------- Fin ajout CI --------------------
//----------------- Debut ajout CI (varianteec) -----
// A mettre aprs le test ci_lecture_rubrique
// Cas d'un rdacteur promu gestionnaire de la rubrique
if ($connect_statut == '0minirezo' AND $ci_statut_initial == '1comite') {
	$flag_editable=true;
}	
//--------- Fin ajout CI --------------------------

//--------- Debut ajout CI (publier une rubrique) -----
if ($flag_editable) {
	$rubrique_non_depubliable = false;

	if ($statut_nouv=='publie') {
		$query = "UPDATE spip_rubriques SET statut=\"$statut_nouv\" WHERE id_rubrique=$id_rubrique";
		$result = spip_query($query);
	}
	if ($statut_nouv=='prive') {
		$rubriques_publiques = calculer_rubriques();
		if ($rubriques_publiques){
			$query = "UPDATE spip_rubriques SET statut=\"$statut_nouv\" WHERE id_rubrique=$id_rubrique AND id_rubrique NOT IN ($rubriques_publiques)";
			$result = spip_query($query);
			$query2 = "SELECT id_rubrique FROM spip_rubriques WHERE id_rubrique=$id_rubrique AND id_rubrique IN ($rubriques_publiques)";
			$result2 = spip_query($query2);
			if ($row = @spip_fetch_array($result2)) {
				$rubrique_non_depubliable = true;
			}

		} else {
			$query = "UPDATE spip_rubriques SET statut=\"$statut_nouv\" WHERE id_rubrique=$id_rubrique";
			$result = spip_query($query);
		}
	}
}
//--------- Fin ajout CI ---------------------

if (!$titre) {
	if ($modifier_rubrique == "oui") calculer_rubriques();
}
else {
	// creation, le cas echeant
	if ($new == 'oui' AND $flag_editable AND !$id_rubrique) {
		$id_rubrique = spip_abstract_insert("spip_rubriques", 
			"(titre, id_parent)",
			"('"._T('item_nouvelle_rubrique')."', '$id_parent')");

//--------- Debut ajout CI (multisite) -----
// 	pr remplissage du site de publication	
		if (cilire_config('cimultisites')=="oui") {
			$cimotsite=cilire_config('cisite');

			$query = "SELECT id_mot FROM spip_mots WHERE titre='$cimotsite'";
			$result = spip_query($query);
			while($row=spip_fetch_array($result)){
				$ciidmotsite=$row['id_mot'];
			}
			$query = "SELECT * FROM spip_mots_rubriques WHERE id_mot=$ciidmotsite AND id_rubrique=$id_rubrique";
			$result = spip_query($query);
			if (!spip_num_rows($result)) {
				$query = "INSERT INTO spip_mots_rubriques (id_mot,id_rubrique) VALUES ($ciidmotsite, $id_rubrique)";
				$result = spip_query($query);
			}

		}
//--------- Fin ajout CI ---------------------
			
		// Modifier le lien de base pour qu'il prenne en compte le nouvel id
		unset($_POST['id_parent']);
		$_POST['id_rubrique'] = $id_rubrique;
		$clean_link = new Link();
	}

	// si c'est une rubrique-secteur contenant des breves, ne deplacer
	// que si $confirme_deplace == 'oui', et changer l'id_rubrique des
	// breves en question
	if ($GLOBALS['confirme_deplace'] == 'oui'
	AND $id_parent > 0) {
		list($id_secteur) = spip_fetch_array(spip_query(
			"SELECT id_secteur FROM spip_rubriques
			WHERE id_rubrique=$id_parent"));
		if ($id_secteur)
			spip_query("UPDATE spip_breves
				SET id_rubrique=$id_secteur
				WHERE id_rubrique=$id_rubrique");
	}

	if ($flag_editable) {
//------- Debut ajout CI (vite ceux qui mettent <img...> dans le titre -----
		$titre = ci_secure_titre($titre);
//-------- Fin ajout CI -----

		if ($champs_extra) {
			include_ecrire("inc_extra.php3");
			$champs_extra = ", extra = '".addslashes(extra_recup_saisie("rubriques"))."'";
		} 
		spip_query("UPDATE spip_rubriques SET " .
(acces_rubrique($id_parent) ? "id_parent='$id_parent'," : "") . "
titre='" . addslashes($titre) ."',
descriptif='" . addslashes($descriptif) . "',
texte='" . addslashes($texte) . "'
$champs_extra
WHERE id_rubrique=$id_rubrique");
	}

	calculer_rubriques();
	calculer_langues_rubriques();

	// invalider et reindexer
	if ($invalider_caches) {
		include_ecrire ("inc_invalideur.php3");
		suivre_invalideur("id='id_rubrique/$id_rubrique'");
	}
	if (lire_meta('activer_moteur') == 'oui') {
		include_ecrire ("inc_index.php3");
		marquer_indexer('rubrique', $id_rubrique);
	}
 }

//
// Appliquer le changement de langue
//
if ($changer_lang AND $id_rubrique>0 AND lire_meta('multi_rubriques') == 'oui' AND (lire_meta('multi_secteurs') == 'non' OR $id_parent == 0) AND $flag_editable) {
	if ($changer_lang != "herit")
		spip_query("UPDATE spip_rubriques SET lang='".addslashes($changer_lang)."', langue_choisie='oui' WHERE id_rubrique=$id_rubrique");
	else {
		if ($id_parent == 0)
			$langue_parent = lire_meta('langue_site');
		else {
			$row = spip_fetch_array(spip_query("SELECT lang FROM spip_rubriques WHERE id_rubrique=$id_parent"));
			$langue_parent = $row['lang'];
		}
		spip_query("UPDATE spip_rubriques SET lang='".addslashes($langue_parent)."', langue_choisie='non' WHERE id_rubrique=$id_rubrique");
	}
	calculer_langues_rubriques();
}

//
// infos sur cette rubrique
//

if ($row=spip_fetch_array(spip_query("SELECT * FROM spip_rubriques WHERE id_rubrique='$id_rubrique'"))){
	$id_rubrique=$row['id_rubrique'];
	$id_parent=$row['id_parent'];
	$titre=$row['titre'];
	$descriptif=$row['descriptif'];
	$texte=$row['texte'];
	$statut = $row['statut'];
	$extra = $row["extra"];
	$langue_rubrique = $row['lang'];
}

if ($titre)
	$titre_page = "&laquo; ".textebrut(typo($titre))." &raquo;";
else
	$titre_page = _T('titre_naviguer_dans_le_site');


///// debut de la page
debut_page($titre_page, "documents", "rubriques");


//////// parents


debut_grand_cadre();

if ($id_rubrique  > 0) {
	afficher_hierarchie($id_parent);
}

fin_grand_cadre();

changer_typo('', 'rubrique'.$id_rubrique);


debut_gauche();

if ($spip_display != 4) {
	if ($id_rubrique > 0) {
		debut_boite_info();
		echo "<CENTER>";
		echo "<FONT FACE='Verdana,Arial,Sans,sans-serif' SIZE=1><B>"._T('titre_numero_rubrique')."</B></FONT>";
		echo "<BR><FONT FACE='Verdana,Arial,Sans,sans-serif' SIZE=6><B>$id_rubrique</B></FONT>";
		echo "</CENTER>";
	
		voir_en_ligne ('rubrique', $id_rubrique, $statut);
	
		fin_boite_info();
	}
	
	//
	// Logos de la rubrique
	//
	
	if ($connect_statut == '0minirezo' AND acces_rubrique($id_rubrique)) {
		if ($id_rubrique)
			afficher_boite_logo('rub', 'id_rubrique', $id_rubrique,
			_T('logo_rubrique')." ".aide ("rublogo"), _T('logo_survol'));
		else
			afficher_boite_logo('rub', 'id_rubrique', 0,
			_T('logo_standard_rubrique')." ".aide ("rublogo"),
			_T('logo_survol'));
	}
	
	
	//
	// Afficher les boutons de creation d'article et de breve
	//
	debut_raccourcis();
	

	icone_horizontale(_T('icone_tous_articles'), "articles_page.php3", "article-24.gif");
	
	if (spip_num_rows(spip_query("SELECT id_rubrique FROM spip_rubriques LIMIT 0,1")) > 0) {
		if ($id_rubrique > 0)
			icone_horizontale(_T('icone_ecrire_article'), "articles_edit.php3?id_rubrique=$id_rubrique&new=oui", "article-24.gif","creer.gif");
	
		$activer_breves = lire_meta("activer_breves");
		if ($activer_breves != "non" AND $id_parent == "0" AND $id_rubrique != "0") {
			icone_horizontale(_T('icone_nouvelle_breve'), "breves_edit.php3?id_rubrique=$id_rubrique&new=oui", "breve-24.gif","creer.gif");
		}
	}
	else {
		if ($connect_statut == '0minirezo') {
			echo "<p>"._T('info_creation_rubrique');
		}
	}
	
	fin_raccourcis();
}


debut_droite();


if ($id_rubrique == 0) {
	$nom_site = lire_meta("nom_site");
	$titre = _T('info_racine_site').": ".$nom_site;
}

if ($id_rubrique ==  0) $ze_logo = "racine-site-24.gif";
else if ($id_parent == 0) $ze_logo = "secteur-24.gif";
else $ze_logo = "rubrique-24.gif";


debut_cadre_relief($ze_logo);

echo "\n<table cellpadding=0 cellspacing=0 border=0 width='100%'>";
echo "<tr width='100%'><td width='100%' valign='top'>";
gros_titre((!acces_restreint_rubrique($id_rubrique) ? '' :
	   http_img_pack("admin-12.gif",'', "width='12' height='12'",
			 _T('info_administrer_rubrique'))) .
	   $titre);
echo "</td>";

if ($id_rubrique > 0 AND $flag_editable) {
	echo "<td>", http_img_pack("rien.gif", ' ', "width='5'") ."</td>\n";
	echo "<td  align='$spip_lang_right' valign='top'>";
	icone(_T('icone_modifier_rubrique'), "rubriques_edit.php3?id_rubrique=$id_rubrique&retour=nav", $ze_logo, "edit.gif");
	echo "</td>";
}
echo "</tr>\n";

if (strlen($descriptif) > 1) {
	echo "<tr><td>\n";
	echo "<div align='$spip_lang_left' style='padding: 5px; border: 1px dashed #aaaaaa;'>";
	echo "<font size=2 face='Verdana,Arial,Sans,sans-serif'>";
	echo propre($descriptif."~");
	echo "</font>";
	echo "</div></td></tr>\n";
}

echo "</table>\n";

	if ($champs_extra AND $extra) {
		include_ecrire("inc_extra.php3");
		extra_affichage($extra, "rubriques");
	}


/// Mots-cles
//--------------------- Debut ajout CI (masquer les mots cls techniques) -----
// if ($flag_mots!= 'non' AND $flag_editable AND $options == 'avancees' AND $id_rubrique > 0) {
if ($flag_mots!= 'non' AND $flag_editable AND $id_rubrique > 0) {
	// impratif sinon en interface simplifie on ne peut pas affecter les mots-cls techniques
//--------------------- Fin ajout CI ------------------
	echo "\n<p>";
	formulaire_mots('rubriques', $id_rubrique, $nouv_mot, $supp_mot, $cherche_mot, $flag_editable);
}

//--------------------- Debut ajout CI (masquer les mots cls techniques) -----
if ($flag_editable AND $id_rubrique > 0) {
    $ci_multi=false;
		if (cilire_config('cimultisites')=="oui") {
	      $ci_multi=true;
		}
	if($ci_multi){
		if ($connect_statut != '0minirezo' OR !$connect_toutes_rubriques) {
			$ciflag_editable = false;
		} else {
			$ciflag_editable = true;
		}
		// le dernier paramtre correspond  l'accs  tous les mots ou non par un administrateur restreint
		ci_formulaire_plusieurs_choix('_a_publier_sur_le_site', 'A publier sur le site','', 'Il est INDISPENSABLE de choisir au moins un site.', 'Choisir un ou plusieurs sites : ', 'oui', 'rubriques', $id_rubrique, $nouv_mot, $supp_mot, $cherche_mot, $ciflag_editable);
	}
	ci_formulaire_un_choix($ciformgroupe,'_forme_rubrique', 'Choix de la forme (gabarit de la page)', 'rubriques', $id_rubrique, $nouv_mot, $supp_mot, $cherche_mot, $flag_editable);
	ci_formulaire_plusieurs_choix('_affichage_rubrique', _T('titre_equip_affichage'), _T('titre_equip_ajouter_raccourci'), _T('titre_equip_expliquer_raccourci'), 'Ajouter un raccourci sur la page d\'accueil, etc. : ', 'non', 'rubriques', $id_rubrique, $nouv_mot, $supp_mot, $cherche_mot, $flag_editable);
	ci_formulaire_un_choix($ciformgroupe,'_articles_ordre_de_tri', 'Ordre de tri des articles', 'rubriques', $id_rubrique, $nouv_mot, $supp_mot, $cherche_mot, $flag_editable);

	
//------------ Debut ajout CI (varianteec) -----
/*
	$ci_ar =true;
	$ci_ar_heritage=false;
	$ci_ari_heritage=false;
	if (cilire_config('citypesite')=="inter" AND cilire_config('ciarinter')!="oui") {
		$ci_ar =false;
	}
	//--------- Debut ajout CI (ec) -----
	if (ci_ari_heritage($id_rubrique)) {
		$ci_ar =false;
		$ci_ari_heritage=true;
	}			
	if (ci_ar_heritage($id_rubrique)) {
		$ci_ar =false;
		$ci_ar_heritage=true;
	}			
	if($ci_ar AND (!ci_ari($id_rubrique) OR ci_droitauteur('eccma'))){
	//--------- Fin ajout CI -----
		ci_formulaire_un_choix($ciformgroupe,'_acces_restreint', 'Restreindre ou non l\'accs sur le site public', 'rubriques', $id_rubrique, $nouv_mot, $supp_mot, $cherche_mot, $flag_editable);
	}
*/	
//------------ Fin ajout CI -----
}
//--------------------- Fin ajout CI -----


//------------ Debut ajout CI (varianteec) -----
if ($flag_editable AND $id_rubrique > 0 AND (cilire_config('ciautorisear')=="oui")) ciboutonprotection($id_rubrique);
/*
//--------- Debut ajout CI (ec) -----
if ($flag_editable AND $id_rubrique > 0) {
	if ($ci_ari_heritage OR $ci_ar_heritage) {
		if (ci_droitauteur('eccma')) {
			echo "<P>";
			debut_cadre_relief();
			echo "<center>";
			if ($ci_ar_heritage) {
				echo "Par hritage d'une rubrique parente, cette rubrique est en accs restreint sur le site public (aux personnes authentifies).";
			} elseif ($ci_ari_heritage) {
				echo "Par hritage d'une rubrique parente, cette rubrique est un espace collaboratif (selon les droits d'accs).";
				// ne pas autoriser l'administrateur tout court  grer les droits depuis la rubrique
				if (!($connect_statut == '0minirezo' AND $connect_toutes_rubriques))
				bouton("Gestion des droits d'accs  cette rubrique", "_giseh_droits.php3?id_rubrique=$id_rubrique");
			}	
			echo "</center>";
			fin_cadre_relief();
		} else {
				echo "<P>";
				debut_cadre_relief();
				echo "<center>";
				if ($ci_ari_heritage) {
					echo "Par hritage d'une rubrique parente, cette rubrique est un espace collaboratif (selon les droits d'accs).";
				} elseif ($ci_ar_heritage) {
					echo "Par hritage d'une rubrique parente, cette rubrique est en accs restreint sur le site public (aux personnes authentifies).";
				}
				echo "</center>";
				fin_cadre_relief();
		}	
	} else {	
		// seuls les admin restreint autoris  crer les EC peuvent grer les droits depuis la rubrique
		if (ci_droitauteur('eccma')) {
			$query_ec = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_rubrique=".$id_rubrique." AND lien_mot.id_mot=mots.id_mot AND mots.titre='_acces_indiv'";
			$result_ec = spip_query($query_ec);
			if (spip_num_rows($result_ec)>0) {			
				echo "<P>";
				debut_cadre_relief();
				echo "<center>";
				bouton("Gestion des droits d'accs  cette rubrique", "_giseh_droits.php3?id_rubrique=$id_rubrique");
				echo "</center>";
				fin_cadre_relief();
			}	
		}
	}
}
*/
//------------ Fin ajout CI -----
//--------- Fin ajout CI -----


if (strlen($texte) > 1) {
	echo "\n<p><div align='justify'><font size=3 face='Verdana,Arial,Sans,sans-serif'>";
	echo justifier(propre($texte));
	echo "&nbsp;</font></div>";
}


//
// Langue de la rubrique
//
if ($id_rubrique>0 AND lire_meta('multi_rubriques') == 'oui' AND (lire_meta('multi_secteurs') == 'non' OR $id_parent == 0) AND $flag_editable) {

	$row = spip_fetch_array(spip_query("SELECT lang, langue_choisie FROM spip_rubriques WHERE id_rubrique=$id_rubrique"));
	$langue_rubrique = $row['lang'];
	$langue_choisie_rubrique = $row['langue_choisie'];
	if ($id_parent) {
		$row = spip_fetch_array(spip_query("SELECT lang FROM spip_rubriques WHERE id_rubrique=$id_parent"));
		$langue_parent = $row[0];
	}
	else $langue_parent = lire_meta('langue_site');

	debut_cadre_enfonce('langues-24.gif');
	echo "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=3 WIDTH=100% BACKGROUND=''><TR><TD BGCOLOR='#EEEECC' class='serif2'>";
	echo bouton_block_invisible('languesrubrique');
	echo "<B>";
	echo _T('titre_langue_rubrique');
	echo "&nbsp; (".traduire_nom_langue($langue_rubrique).")";
	echo "</B>";
	echo "</TD></TR></TABLE>";

	echo debut_block_invisible('languesrubrique');
	echo "<div class='verdana2' align='center'>";
	echo menu_langues('changer_lang', $langue_rubrique, '', $langue_parent);
	echo "</div>\n";
	echo fin_block();

	fin_cadre_enfonce();
}

//--------- Debut ajout CI (publier une rubrique) -----
if ($flag_editable AND $id_rubrique > 0) {
	echo "<P>";
	debut_cadre_relief();
	echo "<center>";
	if ($statut == 'publie') {
		echo "<B>"._T('texte_equip_rubrique_statut')."</B> "._T('texte_equip_statut_publiee')." ";
		echo "<img src='img_pack/puce-verte.gif' alt='' width='13' height='14' border='0' NAME='statut'><BR><BR>\n";
		if ($flag_editable) {
			if ($rubrique_non_depubliable) {
				echo _T('texte_equip_rubrique_non_depubliable')."\n";
			} else {
				echo _T('texte_equip_depublier_rubrique')."\n";
				bouton(_T('bouton_equip_depublier_rubrique'), "naviguer.php3?id_rubrique=$id_rubrique&statut_nouv=prive");
			}
		}
	} else {
		echo "<B>"._T('texte_equip_rubrique_statut')."</B> "._T('texte_equip_statut_non_publiee')." ";
		echo "<img src='img_pack/puce-blanche.gif' alt='' width='13' height='14' border='0' NAME='statut'><BR><BR>\n";
		if ($flag_editable) {
			echo _T('texte_equip_publier_rubrique')."\n";
			bouton(_T('bouton_equip_publier_rubrique'), "naviguer.php3?id_rubrique=$id_rubrique&statut_nouv=publie");
		}
	}
	echo "</center>";
	fin_cadre_relief();
}
//--------- Fin ajout CI ---------------------

fin_cadre_relief();


///// Afficher les rubriques 
afficher_enfant_rub($id_rubrique, $flag_editable);



//echo "<div align='$spip_lang_left'>";


//////////  Vos articles en cours de redaction
/////////////////////////

echo "<P>";


//
// Verifier les boucles a mettre en relief
//

$relief = false;

if (!$relief) {
	$query = "SELECT id_article FROM spip_articles AS articles WHERE id_rubrique='$id_rubrique' AND statut='prop'$vos_articles LIMIT 0,1";
	$result = spip_query($query);
	$relief = (spip_num_rows($result) > 0);
}

if (!$relief) {
	$query = "SELECT id_breve FROM spip_breves WHERE id_rubrique='$id_rubrique' AND (statut='prepa' OR statut='prop') LIMIT 0,1";
	$result = spip_query($query);
	$relief = (spip_num_rows($result) > 0);
}

if (!$relief AND lire_meta('activer_syndic') != 'non') {
	$query = "SELECT id_syndic FROM spip_syndic WHERE id_rubrique='$id_rubrique' AND statut='prop' LIMIT 0,1";
	$result = spip_query($query);
	$relief = (spip_num_rows($result) > 0);
}

if (!$relief AND lire_meta('activer_syndic') != 'non' AND $connect_statut == '0minirezo' AND $connect_toutes_rubriques) {
	$query = "SELECT id_syndic FROM spip_syndic WHERE id_rubrique='$id_rubrique' AND (syndication='off' OR syndication='sus') LIMIT 0,1";
	$result = spip_query($query);
	$relief = (spip_num_rows($result) > 0);
}


if ($relief) {
	echo "<p>";
	debut_cadre_couleur();
	echo "<div class='verdana2' style='color: black;'><b>"._T('texte_en_cours_validation')."</b></div><p>";

	//
	// Les articles a valider
	//
	afficher_articles(_T('info_articles_proposes'),
		"WHERE id_rubrique='$id_rubrique' AND statut='prop'$vos_articles ORDER BY date DESC");

	//
	// Les breves a valider
	//
	$query = "SELECT * FROM spip_breves WHERE id_rubrique='$id_rubrique' AND (statut='prepa' OR statut='prop') ORDER BY date_heure DESC";
	afficher_breves(_T('info_breves_valider'), $query, true);

	//
	// Les sites references a valider
	//
	if (lire_meta('activer_syndic') != 'non') {
		include_ecrire("inc_sites.php3");
		afficher_sites(_T('info_site_valider'), "SELECT * FROM spip_syndic WHERE id_rubrique='$id_rubrique' AND statut='prop' ORDER BY nom_site");
	}

	//
	// Les sites a probleme
	//
	if (lire_meta('activer_syndic') != 'non' AND $connect_statut == '0minirezo' AND $connect_toutes_rubriques) {
		include_ecrire("inc_sites.php3");
		afficher_sites(_T('avis_sites_syndiques_probleme'),
			"SELECT * FROM spip_syndic WHERE id_rubrique='$id_rubrique' AND (syndication='off' OR syndication='sus') AND statut='publie' ORDER BY nom_site");
	}

	// Les articles syndiques en attente de validation
	if ($id_rubrique == 0 AND $connect_statut == '0minirezo' AND $connect_toutes_rubriques) {
		$result = spip_query ("SELECT COUNT(*) AS compte FROM spip_syndic_articles WHERE statut='dispo'");
		if (($row = spip_fetch_array($result)) AND $row['compte'])
			echo "<br><small><a href='sites_tous.php3'>".$row['compte']." "._T('info_liens_syndiques_1')."</a> "._T('info_liens_syndiques_2')."</small>";
	}

	fin_cadre_couleur();
}




//////////  Les articles en cours de redaction
/////////////////////////

//--------- Debut ajout CI (visibilite redacteur) -----
// un rdacteur ne voit pas dans une rubrique les articles en cours de rdaction sauf les siens. En revanche,  laide du moteur de recherche dans lespace priv, il peux les trouver et les consulter. Aussi il est plus simple qu'il les voit.
// if ($connect_statut == "0minirezo" AND $options == 'avancees') {
if ($options == 'avancees') {
//--------- Fin ajout CI  ---------------------
	afficher_articles(_T('info_tous_articles_en_redaction'),
		"WHERE statut='prepa' AND id_rubrique='$id_rubrique' ORDER BY date DESC");
}


//////////  Les articles publies
/////////////////////////

afficher_articles(_T('info_tous_articles_presents'),
	"WHERE statut='publie' AND id_rubrique='$id_rubrique' ORDER BY date DESC", true);

if ($id_rubrique > 0){
	echo "<div align='$spip_lang_right'>";
	icone(_T('icone_ecrire_article'), "articles_edit.php3?id_rubrique=$id_rubrique&new=oui", "article-24.gif", "creer.gif");
	echo "</div><p>";
}

//// Les breves

afficher_breves(_T('icone_ecrire_nouvel_article'), "SELECT * FROM spip_breves WHERE id_rubrique='$id_rubrique' AND statut != 'prop' AND statut != 'prepa' ORDER BY date_heure DESC");

$activer_breves=lire_meta("activer_breves");

if ($id_parent == "0" AND $id_rubrique != "0" AND $activer_breves!="non"){
	echo "<div align='$spip_lang_right'>";
	icone(_T('icone_nouvelle_breve'), "breves_edit.php3?id_rubrique=$id_rubrique&new=oui", "breve-24.gif", "creer.gif");
	echo "</div><p>";
}



//// Les sites references

if (lire_meta("activer_sites") == 'oui') {
	include_ecrire("inc_sites.php3");
	afficher_sites(_T('titre_sites_references_rubrique'), "SELECT * FROM spip_syndic WHERE id_rubrique='$id_rubrique' AND statut!='refuse' AND statut != 'prop' AND syndication NOT IN ('off','sus') ORDER BY nom_site");

	$proposer_sites=lire_meta("proposer_sites");
	if ($id_rubrique > 0 AND ($flag_editable OR $proposer_sites > 0)) {
		$link = new Link('sites_edit.php3');
		$link->addVar('id_rubrique', $id_rubrique);
		$link->addVar('target', 'sites.php3');
		$link->addVar('redirect', $clean_link->getUrl());
	
		echo "<div align='$spip_lang_right'>";
		icone(_T('info_sites_referencer'), $link->getUrl(), "site-24.gif", "creer.gif");
		echo "</div><p>";
	}
}

/// Documents associes a la rubrique

if ($id_rubrique>0) {
	# modifs de la description d'un des docs joints
	if ($flag_editable) maj_documents($id_rubrique, 'rubrique');
	 afficher_documents_non_inclus($id_rubrique, "rubrique", $flag_editable);
}



////// Supprimer cette rubrique (si vide)

if (($id_rubrique>0) AND tester_rubrique_vide($id_rubrique) AND $flag_editable) {
	$link = new Link('naviguer.php3');
	$link->addVar('id_rubrique', $id_parent);
	$link->addVar('supp_rubrique', $id_rubrique);

	echo "<p><div align='center'>";
	icone(_T('icone_supprimer_rubrique'), $link->getUrl(), "$ze_logo", "supprimer.gif");
	echo "</div><p>";


}



fin_page();

?>
